<?php
//-- mod : calendar --------------------------------------------------------------------------------
//-- mod : categories hierarchy --------------------------------------------------------------------
//-- mod : cache -----------------------------------------------------------------------------------
/***************************************************************************
 *                               viewtopic.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: viewtopic.php,v 1.186.2.32 2003/06/20 16:34:58 psotfx Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/
define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);
include($phpbb_root_path . 'includes/functions_user_viewed_posts.'.$phpEx);
include($phpbb_root_path . 'includes/translate_language_map.'.$phpEx);
include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_translate_posts.' . $phpEx);
include($phpbb_root_path . 'includes/def_icons.'. $phpEx);
// Start add - Show usergroups MOD
include($phpbb_root_path . 'includes/functions_usergroup.'.$phpEx);
// End add - Show usergroups MOD
//-- mod : calendar --------------------------------------------------------------------------------
//-- add
include($phpbb_root_path . 'includes/functions_calendar.'.$phpEx);
//-- fin mod : calendar ----------------------------------------------------------------------------
// Cache Posts
// Here you can change the style of the CPS indicators
$CPS_Indicator = array(
	'cached' => '<span style="color: limegreen"><b>&bull;</b></span>',
	'not_cached' => '<span style="color: green"><b>&bull;</b></span>',
	'error' => '<span style="color: red"><b>&bull;</b></span>',
	'dont_cache' => '<span style="color: yellow"><b>&bull;</b></span>',
	'off_but_cached' => '<span style="color: orange"><b>&bull;</b></span>',
	'off' => '<span style="color: black"><b>&bull;</b></span>');
// Cache Posts
//
// Start initial var setup
//
$topic_id = $post_id = 0;
$vote_id = array();
if ( isset($HTTP_GET_VARS[POST_TOPIC_URL]) )
{
	$topic_id = intval($HTTP_GET_VARS[POST_TOPIC_URL]);
}
else if ( isset($HTTP_GET_VARS['topic']) )
{
	$topic_id = intval($HTTP_GET_VARS['topic']);
}

if ( isset($HTTP_GET_VARS[POST_POST_URL]))
{
	$post_id = intval($HTTP_GET_VARS[POST_POST_URL]);
}


$start = ( isset($HTTP_GET_VARS['start']) ) ? intval($HTTP_GET_VARS['start']) : 0;

if (!$topic_id && !$post_id)
{
	message_die(GENERAL_MESSAGE, 'Topic_post_not_exist');
}

//////////////////////////////////////////////
//
//   Bedankomat START (1)
//
//////////////////////////////////////////////

if (isset($HTTP_GET_VARS['mode']) && isset($HTTP_GET_VARS['u']) && isset($HTTP_GET_VARS['t']))
{
   // Alle benoetigten Parameter sind schonmal vorhanden. Das ist wenigstens ein Anfang.
   $thx_user_id = intval($HTTP_GET_VARS['u']);
   $thx_topic_id = intval($HTTP_GET_VARS['t']);
   $thx_mode = stripslashes($HTTP_GET_VARS['mode']);

   switch ($thx_mode)
   {
      case 'add_thx':

            $sql = 'SELECT user_id FROM ' .USERS_TABLE. ' WHERE user_id=' .$thx_user_id. ' LIMIT 1';
            if ( !($result = $db->sql_query($sql)) )
            {
               message_die(GENERAL_ERROR, 'Could not obtain user information', '', __LINE__, __FILE__, $sql);
            }
            if (($db->sql_numrows($result) == 0) && ($thx_user_id == -1))
            {

               message_die(GENERAL_ERROR, 'Invalid User-ID', '', __LINE__, __FILE__, $sql);
            }


            $sql = 'SELECT * FROM ' .BEDANKOMAT_TABLE. ' WHERE (user_id=' .$thx_user_id. ') AND (topic_id=' .$thx_topic_id. ') LIMIT 1';
            if ( !($result = $db->sql_query($sql)) )
            {
               message_die(GENERAL_ERROR, 'Could not obtain bedankomat information', '', __LINE__, __FILE__, $sql);
            }
            if ($db->sql_numrows($result) != 0)

break;
case 'add_thx':





            $sql = 'INSERT INTO ' .BEDANKOMAT_TABLE. ' (user_id, topic_id) VALUES (' .$thx_user_id. ', ' .$thx_topic_id. ')';
            if ( !($result = $db->sql_query($sql)) )
            {
               message_die(GENERAL_ERROR, 'Could not update bedankomat information', '', __LINE__, __FILE__, $sql);
            }


            break;
      case 'remove_thx':

            $sql = 'SELECT user_id FROM ' .USERS_TABLE. ' WHERE user_id=' .$thx_user_id. ' LIMIT 1';
            if ( !($result = $db->sql_query($sql)) )
            {
               message_die(GENERAL_ERROR, 'Could not obtain user information', '', __LINE__, __FILE__, $sql);
            }
            if (($db->sql_numrows($result) == 0) && ($thx_user_id == -1))
            {

               message_die(GENERAL_ERROR, 'Invalid User-ID', '', __LINE__, __FILE__, $sql);
            }


            $sql = 'SELECT * FROM ' .BEDANKOMAT_TABLE. ' WHERE (user_id=' .$thx_user_id. ') AND (topic_id=' .$thx_topic_id. ') LIMIT 1';
            if ( !($result = $db->sql_query($sql)) )
            {
               message_die(GENERAL_ERROR, 'Could not obtain bedankomat information', '', __LINE__, __FILE__, $sql);
            }
            if ($db->sql_numrows($result) == 0)
            {

               message_die(GENERAL_ERROR, 'invalid data', '', __LINE__, __FILE__, $sql);
            }


            $sql = 'DELETE FROM ' .BEDANKOMAT_TABLE. ' WHERE (user_id=' .$thx_user_id. ') AND (topic_id=' .$thx_topic_id. ') LIMIT 1';
            if ( !($result = $db->sql_query($sql)) )
            {
               message_die(GENERAL_ERROR, 'Could not update bedankomat information', '', __LINE__, __FILE__, $sql);
            }


            break;
      default:

            message_die(GENERAL_ERROR, 'unknown "mode"', '', __LINE__, __FILE__, $sql);
            break;
   }


   unset( $sql );
   unset( $thx_user_id );
   unset( $thx_topic_id );
   unset( $thx_mode );
}

//////////////////////////////////////////////
//
// Bedankomat Ende (1)
//
//////////////////////////////////////////////

//
// Find topic id if user requested a newer
// or older topic
//
if ( isset($HTTP_GET_VARS['view']) && empty($HTTP_GET_VARS[POST_POST_URL]) )
{
	if ( $HTTP_GET_VARS['view'] == 'newest' )
	{
		if ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_sid']) || isset($HTTP_GET_VARS['sid']) )
		{
			$session_id = isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_sid']) ? $HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_sid'] : $HTTP_GET_VARS['sid'];

			if ( $session_id )
			{
				$sql = "SELECT p.post_id
					FROM " . POSTS_TABLE . " p, " . SESSIONS_TABLE . " s,  " . USERS_TABLE . " u
					WHERE s.session_id = '$session_id'
						AND u.user_id = s.session_user_id
						AND p.topic_id = $topic_id
						AND p.post_time >= u.user_lastvisit
					ORDER BY p.post_time ASC
					LIMIT 1";
				if ( !($result = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, 'Could not obtain newer/older topic information', '', __LINE__, __FILE__, $sql);
				}

				//<!-- BEGIN Unread Post Information to Database Mod -->
				if ( !($row = $db->sql_fetchrow($result)) )
				{
					if ( $topic_id != 0 ) 
					{ 
						redirect("viewtopic.$phpEx?" . 

POST_TOPIC_URL . "=$topic_id"); 
					} 
					else 
					{ 
						message_die(GENERAL_MESSAGE, 'No new posts 

since last visit'); 
					}
				}
//<!-- END Unread Post Information to Database Mod -->
				$post_id = $row['post_id'];

				if (isset($HTTP_GET_VARS['sid']))
				{
					redirect("viewtopic.$phpEx?sid=$session_id&" . POST_POST_URL . "=$post_id#$post_id");
				}
				else
				{
					redirect("viewtopic.$phpEx?" . POST_POST_URL . "=$post_id#$post_id");
				}
			}
		}

		redirect(append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id", true));
	}
	else if ( $HTTP_GET_VARS['view'] == 'next' || $HTTP_GET_VARS['view'] == 'previous' )
	{
		$sql_condition = ( $HTTP_GET_VARS['view'] == 'next' ) ? '>' : '<';
		$sql_ordering = ( $HTTP_GET_VARS['view'] == 'next' ) ? 'ASC' : 'DESC';

		$sql = "SELECT t.topic_id
			FROM " . TOPICS_TABLE . " t, " . TOPICS_TABLE . " t2
			WHERE
				t2.topic_id = $topic_id
				AND t.forum_id = t2.forum_id
                        AND t.topic_moved_id = 0
				AND t.topic_last_post_id $sql_condition t2.topic_last_post_id
			ORDER BY t.topic_last_post_id $sql_ordering
			LIMIT 1";
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, "Could not obtain newer/older topic information", '', __LINE__, __FILE__, $sql);
		}

		if ( $row = $db->sql_fetchrow($result) )
		{
			$topic_id = intval($row['topic_id']);
//-- mod : categories hierarchy --------------------------------------------------------------------
//-- add
			redirect( "./viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id" );
//-- fin mod : categories hierarchy ----------------------------------------------------------------
		}
		else
		{
			$message = ( $HTTP_GET_VARS['view'] == 'next' ) ? 'No_newer_topics' : 'No_older_topics';
			message_die(GENERAL_MESSAGE, $message);
		}
	}
}

//
// This rather complex gaggle of code handles querying for topics but
// also allows for direct linking to a post (and the calculation of which
// page the post is on and the correct display of viewtopic)
//
$join_sql_table = (!$post_id) ? '' : ", " . POSTS_TABLE . " p, " . POSTS_TABLE . " p2 ";
$join_sql = (!$post_id) ? "t.topic_id = $topic_id" : "p.post_id = $post_id AND t.topic_id = p.topic_id AND p2.topic_id = p.topic_id AND p2.post_id <= $post_id";
$count_sql = (!$post_id) ? '' : ", COUNT(p2.post_id) AS prev_posts";

$order_sql = (!$post_id) ? '' : "GROUP BY p.post_id, t.topic_id, t.topic_title, t.topic_status, t.topic_replies, t.topic_time, t.topic_type, t.topic_vote, t.topic_last_post_id, t.topic_first_post_id, t.topic_contest, f.forum_name, f.forum_status, f.forum_id, f.auth_view, f.auth_read, f.auth_post, f.auth_reply, f.auth_edit, f.auth_delete, f.auth_sticky, f.auth_announce, f.auth_pollcreate, f.auth_vote, f.auth_attachments, f.auth_ban, f.auth_greencard, f.auth_bluecard, f.auth_contest ORDER BY p.post_id ASC";

//-- mod : calendar --------------------------------------------------------------------------------
// here we added
//	, t.topic_first_post_id, t.topic_calendar_time, t.topic_calendar_duration
//-- modify

$sql = "SELECT t.*, f.*" . $count_sql . "
	FROM " . TOPICS_TABLE . " t, " . FORUMS_TABLE . " f" . $join_sql_table . "
	WHERE $join_sql
		AND f.forum_id = t.forum_id
		$order_sql";
		attach_setup_viewtopic_auth($order_sql, $sql);
//-- fin mod : calendar ----------------------------------------------------------------------------

if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Could not obtain topic information", '', __LINE__, __FILE__, $sql);
}

if ( !($forum_topic_data = $db->sql_fetchrow($result)) )
{
	message_die(GENERAL_MESSAGE, 'Topic_post_not_exist');
}

$forum_id = intval($forum_topic_data['forum_id']);
$topic_id = intval($forum_topic_data['topic_id']);
//
// Start session management
//
$userdata = session_pagestart($user_ip, $forum_id, $topic_id);
init_userprefs($userdata);
$pagecounter = "12";
//
// End session management
//
//<!-- BEGIN Unread Post Information to Database Mod -->	
if($userdata['upi2db_access'])
{
    $except_time  = except_time();
    $unread = unread();
}
//<!-- END Unread Post Information to Database Mod -->


//
// Start auth check
//
$is_auth = array();
//-- mod : categories hierarchy --------------------------------------------------------------------
//-- delete
// $is_auth = auth(AUTH_ALL, $forum_id, $userdata, $forum_topic_data);
//
// if( !$is_auth['auth_view'] || !$is_auth['auth_read'] )
//-- add
$is_auth = $tree['auth'][POST_FORUM_URL . $forum_id];

if ( !$is_auth['auth_read'] )
//-- fin mod : categories hierarchy ----------------------------------------------------------------
{
	if ( !$userdata['session_logged_in'] )
	{
		$redirect = ($post_id) ? POST_POST_URL . "=$post_id" : POST_TOPIC_URL . "=$topic_id";
		$redirect .= ($start) ? "&start=$start" : '';
		redirect(append_sid("login.$phpEx?redirect=viewtopic.$phpEx&$redirect", true));
	}

	//-- mod : categories hierarchy --------------------------------------------------------------------
//-- delete
//	$message = ( !$is_auth['auth_view'] ) ? $lang['Topic_post_not_exist'] : sprintf($lang['Sorry_auth_read'], $is_auth['auth_read_type']);
//-- add
	$message = sprintf($lang['Sorry_auth_read'], $is_auth['auth_read_type']);
//-- fin mod : categories hierarchy ----------------------------------------------------------------

	message_die(GENERAL_MESSAGE, $message);
}
//
// End auth check
//
$sig_sql = "SELECT user_show_sig FROM " . USERS_TABLE . " WHERE user_id = " . $userdata['user_id'] . " "; 
if ( !($sig_result = $db->sql_query($sig_sql)) ) 
{ 
message_die(GENERAL_ERROR, 'Could not obtain private User Settings', '', __LINE__, __FILE__, $sql); 
} 

if ( $sig_row = $db->sql_fetchrow($sig_result) ) 
{ 
$show_sig = $sig_row['user_show_sig']; 
} 


// Start add - Who viewed a topic MOD
$user_id=$userdata['user_id'];
$sql='UPDATE '.TOPIC_VIEW_TABLE.' SET topic_id="'.$topic_id.'", view_time="'.time().'", view_count=view_count+1 WHERE topic_id='.$topic_id.' AND user_id='.$user_id;
if ( !$db->sql_query($sql) || !$db->sql_affectedrows() )
{
	$sql = 'INSERT IGNORE INTO '.TOPIC_VIEW_TABLE.' (topic_id, user_id, view_time,view_count)
		VALUES ('.$topic_id.', "'.$user_id.'", "'.time().'","1")';
	if ( !($db->sql_query($sql)) )
	{
		message_die(CRITICAL_ERROR, 'Error create user view topic information ', '', __LINE__, __FILE__, $sql);
	}
}
// Start add - Who viewed a topic MOD

//-- mod : categories hierarchy --------------------------------------------------------------------
//-- delete
// $forum_name = $forum_topic_data['forum_name'];
//-- add
$forum_name = get_object_lang(POST_FORUM_URL . $forum_topic_data['forum_id'], 'name');
$topic_forum_id = $forum_topic_data['forum_id'];
$topic_topic_title = $forum_topic_data['topic_title'];
//-- fin mod : categories hierarchy ----------------------------------------------------------------
$topic_title = $forum_topic_data['topic_title'];
$topic_id = intval($forum_topic_data['topic_id']);
$topic_time = $forum_topic_data['topic_time'];
//-- mod : calendar --------------------------------------------------------------------------------
//-- add
$topic_first_post_id = intval($forum_topic_data['topic_first_post_id']);
$topic_calendar_time = intval($forum_topic_data['topic_calendar_time']);
$topic_calendar_duration = intval($forum_topic_data['topic_calendar_duration']);
//-- fin mod : calendar ----------------------------------------------------------------------------


if ($post_id)
{
	$start = floor(($forum_topic_data['prev_posts'] - 1) / intval($board_config['posts_per_page'])) * intval($board_config['posts_per_page']);
}

//
// Is user watching this thread?
//
if( $userdata['session_logged_in'] )
{
	$can_watch_topic = TRUE;

	$sql = "SELECT notify_status
		FROM " . TOPICS_WATCH_TABLE . "
		WHERE topic_id = $topic_id
			AND user_id = " . $userdata['user_id'];
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Could not obtain topic watch information", '', __LINE__, __FILE__, $sql);
	}

	if ( $row = $db->sql_fetchrow($result) )
	{
		if ( isset($HTTP_GET_VARS['unwatch']) )
		{
			if ( $HTTP_GET_VARS['unwatch'] == 'topic' )
			{
				$is_watching_topic = 0;

				$sql_priority = (SQL_LAYER == "mysql") ? "LOW_PRIORITY" : '';
				$sql = "DELETE $sql_priority FROM " . TOPICS_WATCH_TABLE . "
					WHERE topic_id = $topic_id
						AND user_id = " . $userdata['user_id'];
				if ( !($result = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, "Could not delete topic watch information", '', __LINE__, __FILE__, $sql);
				}
			}

			$template->assign_vars(array(
				'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">')
			);

			$message = $lang['No_longer_watching'] . '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">', '</a>');
			message_die(GENERAL_MESSAGE, $message);
		}
		else
		{
			$is_watching_topic = TRUE;

			if ( $row['notify_status'] )
			{
				$sql_priority = (SQL_LAYER == "mysql") ? "LOW_PRIORITY" : '';
				$sql = "UPDATE $sql_priority " . TOPICS_WATCH_TABLE . "
					SET notify_status = 0
					WHERE topic_id = $topic_id
						AND user_id = " . $userdata['user_id'];
				if ( !($result = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, "Could not update topic watch information", '', __LINE__, __FILE__, $sql);
				}
			}
		}
	}
	else
	{
		if ( isset($HTTP_GET_VARS['watch']) )
		{
			if ( $HTTP_GET_VARS['watch'] == 'topic' )
			{
				$is_watching_topic = TRUE;

				$sql_priority = (SQL_LAYER == "mysql") ? "LOW_PRIORITY" : '';
				$sql = "INSERT $sql_priority INTO " . TOPICS_WATCH_TABLE . " (user_id, topic_id, notify_status)
					VALUES (" . $userdata['user_id'] . ", $topic_id, 0)";
				if ( !($result = $db->sql_query($sql)) )
				{
					message_die(GENERAL_ERROR, "Could not insert topic watch information", '', __LINE__, __FILE__, $sql);
				}
			}

			$template->assign_vars(array(
				'META' => '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">')
			);

			$message = $lang['You_are_watching'] . '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start") . '">', '</a>');
			message_die(GENERAL_MESSAGE, $message);
		}
		else
		{
			$is_watching_topic = 0;
		}
	}
}
else
{
	if ( isset($HTTP_GET_VARS['unwatch']) )
	{
		if ( $HTTP_GET_VARS['unwatch'] == 'topic' )
		{
			redirect(append_sid("login.$phpEx?redirect=viewtopic.$phpEx&" . POST_TOPIC_URL . "=$topic_id&unwatch=topic", true));
		}
	}
	else
	{
		$can_watch_topic = 0;
		$is_watching_topic = 0;
	}
}

//
// Generate a 'Show posts in previous x days' select box. If the postdays var is POSTed
// then get it's value, find the number of topics with dates newer than it (to properly
// handle pagination) and alter the main query
//

$previous_days = array(0, 1, 7, 14, 30, 90, 180, 364);
$previous_days_text = array($lang['All_Posts'], $lang['1_Day'], $lang['7_Days'], $lang['2_Weeks'], $lang['1_Month'], $lang['3_Months'], $lang['6_Months'], $lang['1_Year']);

if( !empty($HTTP_POST_VARS['postdays']) || !empty($HTTP_GET_VARS['postdays']) )
{
	$post_days = ( !empty($HTTP_POST_VARS['postdays']) ) ? intval($HTTP_POST_VARS['postdays']) : intval($HTTP_GET_VARS['postdays']);
	$min_post_time = time() - (intval($post_days) * 86400);

	$sql = "SELECT COUNT(p.post_id) AS num_posts
		FROM " . TOPICS_TABLE . " t, " . POSTS_TABLE . " p
		WHERE t.topic_id = $topic_id
			AND p.topic_id = t.topic_id
			AND p.post_time >= $min_post_time";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Could not obtain limited topics count information", '', __LINE__, __FILE__, $sql);
	}

	$total_replies = ( $row = $db->sql_fetchrow($result) ) ? intval($row['num_posts']) : 0;

	$limit_posts_time = "AND p.post_time >= $min_post_time ";

	if ( !empty($HTTP_POST_VARS['postdays']))
	{
		$start = 0;
	}
}
else
{
	$total_replies = intval($forum_topic_data['topic_replies']) + 1;

	$limit_posts_time = '';
	$post_days = 0;
}

$select_post_days = '<select name="postdays">';
for($i = 0; $i < count($previous_days); $i++)
{
	$selected = ($post_days == $previous_days[$i]) ? ' selected="selected"' : '';
	$select_post_days .= '<option value="' . $previous_days[$i] . '"' . $selected . '>' . $previous_days_text[$i] . '</option>';
}
$select_post_days .= '</select>';

//
// Decide how to order the post display
//
if ( !empty($HTTP_POST_VARS['postorder']) || !empty($HTTP_GET_VARS['postorder']) )
{
	$post_order = (!empty($HTTP_POST_VARS['postorder'])) ? $HTTP_POST_VARS['postorder'] : $HTTP_GET_VARS['postorder'];
	$post_time_order = ($post_order == "asc") ? "ASC" : "DESC";
}
else
{
	$post_order = 'asc';
	$post_time_order = 'ASC';
}

$select_post_order = '<select name="postorder">';
if ( $post_time_order == 'ASC' )
{
	$select_post_order .= '<option value="asc" selected="selected">' . $lang['Oldest_First'] . '</option><option value="desc">' . $lang['Newest_First'] . '</option>';
}
else
{
	$select_post_order .= '<option value="asc">' . $lang['Oldest_First'] . '</option><option value="desc" selected="selected">' . $lang['Newest_First'] . '</option>';
}
$select_post_order .= '</select>';

update_user_viewed($userdata['user_id'], $topic_id);

// Similar Topics
$sql = "SELECT topic_id
FROM ". TOPICS_TABLE ."
WHERE topic_id != $topic_id
AND MATCH (topic_title) AGAINST ('". addslashes($topic_title) ."')
ORDER BY topic_time DESC LIMIT 0,5";
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Could not get main information for similar topics", '', __LINE__, __FILE__, $sql);
}
$topics = array();
while ( $row = $db->sql_fetchrow($result) )
{
  $topics[] = $row;
}
  $count_similar = count($topics);
if ( $count_similar > 0 )
{
  $template->assign_block_vars('similar', array(
         'L_SIMILAR' => $lang['Similar'],
         'L_TOPIC' => $lang['Topic'],
         'L_AUTHOR' => $lang['Author'],
         'L_FORUM' =>  $lang['Forum'],
         'L_REPLIES' => $lang['Replies'],
         'L_LAST_POST' => $lang['Posted'])
  );
  

for($i = 0; $i < $count_similar; $i++)
{
  $sql = "SELECT t.topic_type, t.topic_status, t.topic_id, t.topic_title, t.topic_time, t.topic_replies, t.topic_last_post_id, t.topic_cache_lock, u.user_id, u.username, f.forum_id, f.forum_name, p.post_time, p.post_username
  FROM ". TOPICS_TABLE ." t, ". USERS_TABLE ." u, ". FORUMS_TABLE ." f, ". POSTS_TABLE ." p
  WHERE t.topic_id = '". $topics[$i]['topic_id'] ."'
  AND f.forum_id = t.forum_id
  AND p.topic_id = t.topic_id 
  AND u.user_id = p.poster_id
  GROUP BY t.topic_id";
 if ( !($result = $db->sql_query($sql)) )
 {
  	message_die(GENERAL_ERROR, "Could not get similar topics", '', __LINE__, __FILE__, $sql);
 }
  
  while ( $row = $db->sql_fetchrow($result) )
  {
   $similar = $row;
   
   $tracking_topics = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] .'_t']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] .'_t']) : array();
   $tracking_forums = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] .'_f']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] .'_f']) : array();
   $topic_type =  ( $similar['topic_type'] == POST_ANNOUNCE ) ? $lang['Topic_Announcement'] .' ': '';
	 $topic_type .= ( $similar['topic_type'] == POST_STICKY ) ? $lang['Topic_Sticky'] .' ': '';
	 $topic_type .= ( $similar['topic_vote'] ) ? $lang['Topic_Poll'] .' ': '';
   $replies = $similar['topic_replies'];
   
   if( $similar['topic_status'] == TOPIC_LOCKED )
	{
		$folder = $images['folder_locked'];
		$folder_new = $images['folder_locked_new'];
	}
	else if( $similar['topic_type'] == POST_ANNOUNCE )
	{
		$folder = $images['folder_announce'];
		$folder_new = $images['folder_announce_new'];
	}
	else if( $similar['topic_type'] == POST_GLOBAL_ANNOUNCE )
	{
		$folder = $images['folder_global_announce'];
		$folder_new = $images['folder_global_announce_new'];
	}
	else if( $similar['topic_type'] == POST_STICKY )
	{
		$folder = $images['folder_sticky'];
		$folder_new = $images['folder_sticky_new'];
	}
	else
	{
		if( $replies >= $board_config['hot_threshold'] )
		{
			$folder = $images['folder_hot'];
			$folder_new = $images['folder_hot_new'];
		}
		else
		{
			$folder = $images['folder'];
			$folder_new = $images['folder_new'];
		}
	}
  if( $userdata['session_logged_in'] )
	{
		if( $similar['post_time'] > $userdata['user_lastvisit'] ) 
		{
			if( !empty($tracking_topics) || !empty($tracking_forums) || isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] .'_f_all']) )
			{
				$unread_topics = true;
				if( !empty($tracking_topics[$topic_id]) )
				{
					if( $tracking_topics[$topic_id] >= $similar['post_time'] )
					{
						$unread_topics = false;
					}
				}
				if( !empty($tracking_forums[$forum_id]) )
				{
					if( $tracking_forums[$forum_id] >= $similar['post_time'] )
					{
						$unread_topics = false;
					}
				}
				if( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] .'_f_all']) )
				{
					if( $HTTP_COOKIE_VARS[$board_config['cookie_name'] .'_f_all'] >= $similar['post_time'] )
					{
						$unread_topics = false;
					}
				}

				if( $unread_topics )
				{
					$folder_image = $folder_new;
					$folder_alt = $lang['New_posts'];
					$newest_img = '<a href="'. append_sid("viewtopic.$phpEx?". POST_TOPIC_URL ."=$topic_id&amp;view=newest") .'"><img src="'. $images['icon_newest_reply'] .'" alt="'. $lang['View_newest_post'] .'" title="'. $lang['View_newest_post'] .'" border="0" /></a> ';
				}
				else
				{
					$folder_image = $folder;
					$folder_alt = ( $similar['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['No_new_posts'];
					$newest_img = '';
				}
			}
			else
			{
				$folder_image = $folder_new;
				$folder_alt = ( $similar['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['New_posts'];
				$newest_img = '<a href="'. append_sid("viewtopic.$phpEx?". POST_TOPIC_URL ."=$topic_id&amp;view=newest") .'"><img src="'. $images['icon_newest_reply'] .'" alt="'. $lang['View_newest_post'] .'" title="'. $lang['View_newest_post'] .'" border="0" /></a> ';
			}
		}
		else 
		{
			$folder_image = $folder;
			$folder_alt = ( $similar['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['No_new_posts'];
			$newest_img = '';
		}
	}
	else
	{
		$folder_image = $folder;
		$folder_alt = ( $similar['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['No_new_posts'];
		$newest_img = '';
	}

   $title = (strlen($similar['topic_title']) > 40) ? (substr($similar['topic_title'], 0, 37) . '...') : $similar['topic_title']; 
   $topic_url = '<a href="'. append_sid("viewtopic.$phpEx?". POST_TOPIC_URL .'='. $similar['topic_id']) .'">'. $title . '</a>';

   $author_url = append_sid("profile.$phpEx?mode=viewprofile&amp;". POST_USERS_URL .'='. $similar['user_id']);

   $author = ( $similar['user_id'] != ANONYMOUS ) ? '<a href="'. append_sid("profile.$phpEx?mode=viewprofile&amp;". POST_USERS_URL .'='. $similar['user_id']) .'">'. $similar['username'] .'</a>' : ( ($similar['post_username'] != '' ) ? $similar['post_username'] : $lang['Guest'] );
  
   $forum_url = append_sid("viewforum.$phpEx?f=". $similar['forum_id']);  
   $forum = '<a href="'. $forum_url .'">'. $similar['forum_name'] .'</a>';
   $post_url = '<a href="'. append_sid("viewtopic.$phpEx?". POST_POST_URL .'='. $similar['topic_last_post_id']) .'#'. $similar['topic_last_post_id'] .'"><img src="'. $images['icon_latest_reply'] .'" alt="'. $lang['View_latest_post'] .'" title="'. $lang['View_latest_post'] .'" border="0" /></a>';
   $post_time = create_date($board_config['default_dateformat'], $similar['topic_time'], $board_config['board_timezone']);
 
    $template->assign_block_vars('similar.topics', array(
         'FOLDER' => $folder_image,
         'ALT' => $folder_alt,
         'TYPE' => $topic_type,
         'TOPICS' => $topic_url,
         'AUTHOR' => $author,
         'FORUM' => $forum,
         'REPLIES' => $replies,
         'NEWEST' => $newest_img,
         'POST_TIME' => $post_time,
         'POST_URL' => $post_url)
    );
  } // while
 } // for $i
} // if ( $count_similar > 0 )
//
// Go ahead and pull all data for this topic
//
$sql = "SELECT u.*,  u.user_level, p.*,  pt.post_text, pt.post_subject, pt.post_extra, pt.bbcode_uid
	FROM " . POSTS_TABLE . " p, " . USERS_TABLE . " u, " . POSTS_TEXT_TABLE . " pt
	WHERE p.topic_id = $topic_id
		$limit_posts_time
		AND pt.post_id = p.post_id
		AND u.user_id = p.poster_id
	ORDER BY p.post_time $post_time_order
	LIMIT $start, ".$board_config['posts_per_page'];
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Could not obtain post/user information.", '', __LINE__, __FILE__, $sql);
}

$postrow = array();
if ($row = $db->sql_fetchrow($result))
{
	do
	{
		$postrow[] = $row;


	}
	while ($row = $db->sql_fetchrow($result));
	$db->sql_freeresult($result);

	$total_posts = count($postrow);
}
else
{
   include($phpbb_root_path . 'includes/functions_admin.' . $phpEx);
   sync('topic', $topic_id);

   message_die(GENERAL_MESSAGE, $lang['No_posts_topic']);
}

$resync = FALSE;
if ($forum_topic_data['topic_replies'] + 1 < $start + count($postrow))
{
   $resync = TRUE;
}
elseif ($start + $board_config['posts_per_page'] > $forum_topic_data['topic_replies'])
{
   $row_id = intval($forum_topic_data['topic_replies']) % intval($board_config['posts_per_page']);
   if ($postrow[$row_id]['post_id'] != $forum_topic_data['topic_last_post_id'] || $start + count($postrow) < $forum_topic_data['topic_replies'])
   {
      $resync = TRUE;
   }
}
elseif (count($postrow) < $board_config['posts_per_page'])
{
   $resync = TRUE;
}

if ($resync)
{
   include($phpbb_root_path . 'includes/functions_admin.' . $phpEx);
   sync('topic', $topic_id);

   $result = $db->sql_query('SELECT COUNT(post_id) AS total FROM ' . POSTS_TABLE . ' WHERE topic_id = ' . $topic_id);
   $row = $db->sql_fetchrow($result);
   $total_replies = $row['total'];
}
//-- mod : cache -----------------------------------------------------------------------------------
//-- add
$ranks = array();
$ranksrow = array();
if ( defined('CACHE_RANKS') )
{
	@include( $phpbb_root_path . './includes/def_ranks.' . $phpEx );
	if ( empty($ranks) )
	{
		cache_ranks();
		include( $phpbb_root_path . './includes/def_ranks.' . $phpEx );
	}
	@reset($ranks);
	while ( list($rank_id, $rank_data) = @each($ranks) )
	{
		$ranksrow[] = $rank_data;
	}
}
if ( empty($ranks) && !defined('CACHE_RANKS') )
{
//-- fin mod : cache -------------------------------------------------------------------------------
//-- mod : cache -----------------------------------------------------------------------------------
//-- add
$ranks = array();
$ranksrow = array();
if ( defined('CACHE_RANKS') )
{
	@include( $phpbb_root_path . './includes/def_ranks.' . $phpEx );
	if ( empty($ranks) )
	{
		cache_ranks();
		include( $phpbb_root_path . './includes/def_ranks.' . $phpEx );
	}
	@reset($ranks);
	while ( list($rank_id, $rank_data) = @each($ranks) )
	{
		$ranksrow[] = $rank_data;
	}
}
if ( empty($ranks) && !defined('CACHE_RANKS') )
{
//-- fin mod : cache -------------------------------------------------------------------------------
$sql = "SELECT *
	FROM " . RANKS_TABLE . "
	ORDER BY rank_special, rank_min";
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Could not obtain ranks information.", '', __LINE__, __FILE__, $sql);
}

$ranksrow = array();
while ( $row = $db->sql_fetchrow($result) )
{
	$ranksrow[] = $row;
}
$db->sql_freeresult($result);
//-- mod : cache -----------------------------------------------------------------------------------
//-- add
}
//-- fin mod : cache -------------------------------------------------------------------------------
//-- mod : cache -----------------------------------------------------------------------------------
//-- add
}
//-- fin mod : cache -------------------------------------------------------------------------------
//
// Define censored word matches
//
$orig_word = array();
$replacement_word = array();
obtain_word_list($orig_word, $replacement_word);

//
// Censor topic title
//
if ( count($orig_word) )
{
	$topic_title = preg_replace($orig_word, $replacement_word, $topic_title);
}

//
// Word hightlighter with CrackerTracker Protection Engine
// Security System powered by http://www.cback.de
//
$highlight_match = $highlight = '';
if (isset($HTTP_GET_VARS['highlight']))
{
    

    // Split words and phrases
    $words = explode(' ', trim(htmlspecialchars($HTTP_GET_VARS['highlight'])));


	for($i = 0; $i < sizeof($words); $i++)
	{
		if (trim($words[$i]) != '')
		{
			$highlight_match .= (($highlight_match != '') ? '|' : '') . str_replace('*', '\w*', preg_quote($words[$i], '#'));


		}
	}
	unset($words);

	$highlight = urlencode($HTTP_GET_VARS['highlight']);
$highlight_match = phpbb_rtrim($highlight_match, "\\");

}

//
// Post, reply and other URL generation for
// templating vars
//
$new_topic_url = append_sid("posting.$phpEx?mode=newtopic&amp;" . POST_FORUM_URL . "=$forum_id");
$reply_topic_url = append_sid("posting.$phpEx?mode=reply&amp;" . POST_TOPIC_URL . "=$topic_id");
$export_topic_url = append_sid("export.$phpEx?mode=txt&amp;" . POST_TOPIC_URL . "=$topic_id");
$view_forum_url = append_sid("viewforum.$phpEx?" . POST_FORUM_URL . "=$forum_id");
$view_prev_topic_url = append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;view=previous");
$view_next_topic_url = append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;view=next");

//
// Mozilla navigation bar
//
$nav_links['prev'] = array(
	'url' => $view_prev_topic_url,
	'title' => $lang['View_previous_topic']
);
$nav_links['next'] = array(
	'url' => $view_next_topic_url,
	'title' => $lang['View_next_topic']
);
$nav_links['up'] = array(
	'url' => $view_forum_url,
	'title' => $forum_name
);

$reply_img = ( $forum_topic_data['forum_status'] == FORUM_LOCKED || $forum_topic_data['topic_status'] == TOPIC_LOCKED ) ? $images['reply_locked'] : $images['reply_new'];
$reply_fast_img = ( $forum_topic_data['forum_status'] == FORUM_LOCKED || $forum_topic_data['topic_status'] == TOPIC_LOCKED ) ? $images['reply_fast_locked'] : $images['reply_fast'];
$reply_alt = ( $forum_topic_data['forum_status'] == FORUM_LOCKED || $forum_topic_data['topic_status'] == TOPIC_LOCKED ) ? $lang['Topic_locked'] : $lang['Reply_to_topic'];
$post_img = ( $forum_topic_data['forum_status'] == FORUM_LOCKED ) ? $images['post_locked'] : $images['post_new'];
$post_alt = ( $forum_topic_data['forum_status'] == FORUM_LOCKED ) ? $lang['Forum_locked'] : $lang['Post_new_topic'];

//
// Set a cookie for this topic
//
if ( $userdata['session_logged_in'] )
{
	$tracking_topics = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) : array();
	$tracking_forums = ( isset($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) : array();

	if ( !empty($tracking_topics[$topic_id]) && !empty($tracking_forums[$forum_id]) )
	{
		$topic_last_read = ( $tracking_topics[$topic_id] > $tracking_forums[$forum_id] ) ? $tracking_topics[$topic_id] : $tracking_forums[$forum_id];
	}
	else if ( !empty($tracking_topics[$topic_id]) || !empty($tracking_forums[$forum_id]) )
	{
		$topic_last_read = ( !empty($tracking_topics[$topic_id]) ) ? $tracking_topics[$topic_id] : $tracking_forums[$forum_id];
	}
	else
	{
		$topic_last_read = $userdata['user_lastvisit'];
	}

	if ( count($tracking_topics) >= 150 && empty($tracking_topics[$topic_id]) )
	{
		asort($tracking_topics);
		unset($tracking_topics[key($tracking_topics)]);
	}

	$tracking_topics[$topic_id] = time();

	setcookie($board_config['cookie_name'] . '_t', serialize($tracking_topics), 0, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);
}
//<!-- BEGIN Unread Post Information to Database Mod --> 
if($userdata['upi2db_access']) 
{ 
    $unread_new_posts = 0; 
    $unread_edit_posts = 0; 
    for($i = 0; $i < $total_posts; $i++) 
    { 
        if (sizeof($unread[$topic_id]['new_posts']) && 

in_array($postrow[$i]['post_id'],$unread[$topic_id]['new_posts'])) 
       { 
           ++$unread_new_posts; 
        } 
       if (sizeof($unread[$topic_id]['edit_posts']) && 

in_array($postrow[$i]['post_id'],$unread[$topic_id]['edit_posts'])) 
       { 
           ++$unread_edit_posts; 
        } 
    } 
} 
//<!-- END Unread Post Information to Database Mod -->
//
// Load templates
//
$template->set_filenames(array(
	'body' => 'viewtopic_body.tpl')
);
make_jumpbox('viewforum.'.$phpEx, $forum_id);

//
// Output page header
//
$page_title = $lang['View_topic'] .' - ' . $topic_title;
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

//
// User authorisation levels output
//
$s_auth_can = ( ( $is_auth['auth_post'] ) ? $lang['Rules_post_can'] : $lang['Rules_post_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_reply'] ) ? $lang['Rules_reply_can'] : $lang['Rules_reply_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_edit'] ) ? $lang['Rules_edit_can'] : $lang['Rules_edit_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_delete'] ) ? $lang['Rules_delete_can'] : $lang['Rules_delete_cannot'] ) . '<br />';
$s_auth_can .= ( ( $is_auth['auth_vote'] ) ? $lang['Rules_vote_can'] : $lang['Rules_vote_cannot'] ) . '<br />';
attach_build_auth_levels($is_auth, $s_auth_can);
$s_auth_can .= ( $is_auth['auth_ban'] ) ? $lang['Rules_ban_can'] . "<br />" : "";
$s_auth_can .= ( $is_auth['auth_greencard'] ) ? $lang['Rules_greencard_can'] . "<br />" : "";
$s_auth_can .= ( $is_auth['auth_bluecard'] ) ? $lang['Rules_bluecard_can'] . "<br />" : "";

$topic_mod = '';

if ( $is_auth['auth_mod'] ) 
{ 
$s_auth_can .= sprintf($lang['Rules_moderate'], "<a href=\"modcp.$phpEx?" . POST_FORUM_URL . "=$forum_id&amp;sid=" . $userdata['session_id'] . '">', '</a>'); 
$topic_mod .= "<b>Dieses Thema:</b> <a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=delete&amp;sid=" . $userdata['session_id'] . '" alt="' . $lang['Delete_topic'] . '" title="' . $lang['Delete_topic'] . '" border="0" class="cattitle"/>' . $lang['Delete'] . '</a>&nbsp;|&nbsp;'; 
$topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=move&amp;sid=" . $userdata['session_id'] . '" alt="' . $lang['Move_topic'] . '" title="' . $lang['Move_topic'] . '" border="0" class="cattitle"/>' . $lang['Move'] . '</a>&nbsp;|&nbsp;'; 
$topic_mod .= ( $forum_topic_data['topic_status'] == TOPIC_UNLOCKED ) ? "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=lock&amp;sid=" . $userdata['session_id'] . '" border="0" class="cattitle">' . $lang['Lock'] . '</a>&nbsp;|&nbsp;' : "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=unlock&amp;sid=" . $userdata['session_id'] . '" border="0" class="cattitle">' . $lang['Unlock'] . '</a>&nbsp;|&nbsp;'; 
$topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=mergepost&amp;sid=" . $userdata['session_id'] . '" border="0" class="cattitle">' . $lang['Merge'] . '</a>&nbsp;|&nbsp;'; 
$topic_mod .= "<a href=\"modcp.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;mode=split&amp;sid=" . $userdata['session_id'] . '" alt="' . $lang['Split_topic'] . '" title="' . $lang['Split_topic'] . '" border="0" class="cattitle"/>' . $lang['Split'] . '</a>&nbsp;'; 
} 

/////////////////////////////////////////////////////////
//
//   Bedankomat-Start (2)
//
/////////////////////////////////////////////////////////
if ($userdata['session_logged_in'] && $forum_topic_data['topic_bedankomat'] == TRUE) 
{ 

$allow_remove_thanks = 1; // noch nicht implementiert !!!!! 

$template->assign_block_vars('switch_bedankomat_on', array()); 



//  }


   $sql = 'SELECT * FROM ' .BEDANKOMAT_TABLE. ' WHERE (user_id=' . $userdata['user_id'] . ') AND (topic_id=' .$topic_id. ') LIMIT 1';
   if ( !($result = $db->sql_query($sql)) )
   {
      message_die(GENERAL_ERROR, 'Could not obtain user-bedankomat information', '', __LINE__, __FILE__, $sql);
   }


   if ($db->sql_numrows($result) == 1)
   {

      $l_bedankomat = ($images['bed_no_thank']) ? '<img src="' . $images['bed_no_thank'] . '" border="0" align="middle">' : $lang['bed_no_thank'];
      $u_bedankomat = append_sid('viewtopic.'.$phpEx.'?mode=remove_thx&amp;u='.$userdata['user_id'].'&amp;t='.$topic_id);
   }
   else
   {

      $l_bedankomat = ($images['bed_thank']) ? '<img src="' . $images['bed_thank'] . '" border="0" align="middle">' : $lang['bed_thank'];
      $u_bedankomat = append_sid('viewtopic.'.$phpEx.'?mode=add_thx&amp;u='.$userdata['user_id'].'&amp;t='.$topic_id);
   }
}
else
{
   $l_bedankomat = '';
   $u_bedankomat = '';
}



$sql = 'SELECT b.user_id, b.topic_id, u.username, u.user_level FROM ' .BEDANKOMAT_TABLE. ' b, ' .USERS_TABLE. ' u
   WHERE (b.user_id = u.user_id) AND (b.topic_id = ' .$topic_id. ')';
if ( !($result = $db->sql_query($sql)) )
{
   message_die(GENERAL_ERROR, 'Could not obtain topic-bedankomat information', '', __LINE__, __FILE__, $sql);
}

$thx_users = array();
$num_thxs = $db->sql_numrows($result);
$thx_users = $db->sql_fetchrowset($result);

if ($num_thxs > 0 && $forum_topic_data['topic_bedankomat'] == TRUE)
{
   $l_thx_userlist = '';
   $l_thx_user = $lang['bed_text'];

   for ($index=0; $index<$num_thxs; $index++)
   {
	$style_color = '';
	$bed_username = $thx_users[$index]['username'];
	$bed_userlevel = $thx_users[$index]['user_level'];

	if ( $bed_userlevel == ADMIN )
	{
		$bed_username = '<b>' . $bed_username . '</b>';
		$style_color = 'style="color:#' . $theme['fontcolor3'] . '"';
	}
        else if ( $bed_userlevel == JUNIOR_ADMIN )
        {
        	$bed_username = '<b>' . $bed_username . '</b>';
        	$style_color = 'style="color:#' . $theme['fontcolor5'] . '"';
        }
        else if ( $bed_userlevel == SPONSOR )
        {
        	$bed_username = '<b>' . $bed_username . '</b>';
        	$style_color = 'style="color:#' . $theme['fontcolor7'] . '"';
        }
        else if ( $bed_userlevel == VIP )
        {
        	$bed_username = '<b>' . $bed_username . '</b>';
        	$style_color = 'style="color:#' . $theme['fontcolor8'] . '"';
        }
        else if ( $bed_userlevel == USER )
        {
        	$bed_username = '<b>' . $bed_username . '</b>';
        	$style_color = 'style="color:#' . $theme['body_link'] . '"';
        }
	else if ( $bed_userlevel == MOD )
	{
		$bed_username = '<b>' . $bed_username . '</b>';
		$style_color = 'style="color:#' . $theme['fontcolor2'] . '"';
	}


      $temp = $thx_users[$index]['user_id'];
      $temp = '<a href="' . append_sid("./profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $temp) . '"' . $style_color .'>' . $bed_username . '</a>';
      $l_thx_userlist .= ($index==0) ? $temp : ', ' . $temp;
   }

   $template->assign_block_vars('switch_bedankomat', array() );
}
else
{
   $l_thx_userlist = '';
   $l_thx_user = '';
}

unset( $num_thxs );
unset( $thx_users );

/////////////////////////////////////////////////////////
//
//   Bedankomat-Ende (2)
//
///////////////////////////////////////////////////////// //

//
// Topic watch information
//
$s_watching_topic = '';
if ( $can_watch_topic )
{
   if ( $is_watching_topic )
   {
      $s_watching_topic = "<a href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;unwatch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '">' . $lang['Stop_watching_topic'] . '</a>';
      $s_watching_topic_img = ( isset($images['topic_un_watch']) ) ? "<a href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;unwatch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_un_watch'] . '" alt="' . $lang['Stop_watching_topic'] . '" title="' . $lang['Stop_watching_topic'] . '" border="0" /></a>' : '';
   }
   else
   {
      $s_watching_topic = "<a href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;watch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '">' . $lang['Start_watching_topic'] . '</a>';
      $s_watching_topic_img = ( isset($images['topic_watch']) ) ? "<a href=\"viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;watch=topic&amp;start=$start&amp;sid=" . $userdata['session_id'] . '"><img src="' . $images['topic_watch'] . '" alt="' . $lang['Start_watching_topic'] . '" title="' . $lang['Start_watching_topic'] . '" border="0" /></a>' : '';
   }
}
//<!-- BEGIN Unread Post Information to Database Mod -->				
if($userdata['upi2db_access'])
{
	$mark_always_read = mark_always_read($forum_topic_data['topic_type'], $topic_id, 

$forum_id, 'viewforum', 'txt', $unread);
}
else
{	
	$mark_always_read = '';
}
//<!-- END Unread Post Information to Database Mod -->
//
// If we've got a hightlight set pass it on to pagination,
// I get annoyed when I lose my highlight after the first page.
//
$pagination = ( $highlight != '' ) ? generate_pagination("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order&amp;highlight=$highlight", $total_replies, $board_config['posts_per_page'], $start) : generate_pagination("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order", $total_replies, $board_config['posts_per_page'], $start);
$watch_topic_url = "topic_view_users.$phpEx?".POST_TOPIC_URL."=$topic_id";
// Cache Posts
if ($board_config['enable_post_cache'])
{
	$cps_topic_img = '<a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=recycle_topic&amp;'.POST_TOPIC_URL.'='.$topic_id.'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_recycle_topic'].'" alt="'.$lang['CPS_recycle_topic'].'" title="'.$lang['CPS_recycle_topic'].'" border="0" /></a>&nbsp;';
	$cps_topic_img .= ( !$forum_topic_data['topic_cache_lock'] ) ? '<a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=deactivate_topic&amp;'.POST_TOPIC_URL.'='.$topic_id.'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_deactivate_topic'].'" alt="'.$lang['CPS_dont_cache_topic'].'" title="'.$lang['CPS_dont_cache_topic'].'" border="0" /></a>&nbsp;' : '';
}
else
{
	$cps_topic_img = ($userdata['user_level'] == ADMIN) ? '<a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=delete_topic&amp;'.POST_TOPIC_URL.'='.$topic_id.'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_delete_topic'].'" alt="'.$lang['CPS_delete_topic'].'" title="'.$lang['CPS_delete_topic'].'" border="0" /></a>&nbsp;' : '';
}
// Cache Posts
//
// Send vars to template
//
$template->assign_vars(array(
	'FORUM_ID' => $forum_id,
	'FORUM_NAME' => $forum_name,
	'TOPIC_ID' => $topic_id,
	'TOPIC_TITLE' => $topic_title,
	'PAGINATION' => $pagination,
	'PAGE_NUMBER' => sprintf($lang['Page_of'], ( floor( $start / intval($board_config['posts_per_page']) ) + 1 ), ceil( $total_replies / intval($board_config['posts_per_page']) )),

	'POST_IMG' => $post_img,
	'REPLY_IMG' => $reply_img,
'REPLY_FAST_IMG' => $reply_fast_img,
	'L_PRINT' => ($lang['Print_View']) ? $lang['Print_View'] : 'Printable version',
    	'U_PRINT' => append_sid("printview.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start"),

	'L_AUTHOR' => $lang['Author'],
	'L_MESSAGE' => $lang['Message'],
	'L_POSTED' => $lang['Posted'],
	'L_POST_SUBJECT' => $lang['Post_subject'],
	'L_VIEW_NEXT_TOPIC' => $lang['View_next_topic'],
	'L_VIEW_PREVIOUS_TOPIC' => $lang['View_previous_topic'],
	'L_POST_NEW_TOPIC' => $post_alt,
	'L_POST_REPLY_TOPIC' => $reply_alt,
	'L_BACK_TO_TOP' => $lang['Back_to_top'],
	'L_DISPLAY_POSTS' => $lang['Display_posts'],
	'L_LOCK_TOPIC' => $lang['Lock_topic'],
	'L_UNLOCK_TOPIC' => $lang['Unlock_topic'],
	'L_MOVE_TOPIC' => $lang['Move_topic'],
	'L_SPLIT_TOPIC' => $lang['Split_topic'],
	'L_DELETE_TOPIC' => $lang['Delete_topic'],
	'L_GOTO_PAGE' => $lang['Goto_page'],
	// Bedankomat
	'L_BEDANKOMAT' => $l_bedankomat,
	'U_BEDANKOMAT' => $u_bedankomat,
	'I_BEDANKOMAT' => ($images['bed_titel']) ? '<img src="' . $images['bed_titel'] . '" border="0" align="middle">' : $lang['bed_titel'],
	'L_BEDANKOMAT_USERS' => $l_thx_userlist,
	'L_BEDANKOMAT_TEXT' => $l_thx_user,
        'PAGE_BOTTOM_IMG' => '<a href="#bot"><img src="' . $images['icon_down'] . '" alt="' . $lang['Go_to_bottom'] . '" title="' . $lang['Go_to_bottom'] . '" border="0" /></a>',
        'PAGE_BOTTOM' => '<a href="#bot">' . $lang['Go_to_bottom'] . '</a>',
	'L_TELL_FRIEND' => $lang['Tell_Friend'],
	'L_SAVE_TOPIC' => $lang['Save_Topic'],
	'L_TOPIC_VIEW_USERS' => $lang['Topic_view_users'],

	'S_TOPIC_LINK' => POST_TOPIC_URL,
	'S_SELECT_POST_DAYS' => $select_post_days,
	'S_SELECT_POST_ORDER' => $select_post_order,
	'S_POST_DAYS_ACTION' => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . '=' . $topic_id . "&amp;start=$start"),
	'S_AUTH_LIST' => $s_auth_can,
	'S_TOPIC_ADMIN' => $topic_mod,
// Cache Posts
	'S_CPS_IMG_TOPIC' => ( $is_auth['auth_mod'] && $board_config['allow_cache_moderate'] || $userdata['user_level'] == ADMIN ) ? $cps_topic_img : '',
// Cache Posts
	'S_WATCH_TOPIC' => $s_watching_topic,
	'S_WATCH_TOPIC_IMG' => $s_watching_topic_img,

	'U_VIEW_TOPIC' => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;start=$start&amp;postdays=$post_days&amp;postorder=$post_order&amp;highlight=$highlight"),
//<!-- BEGIN Unread Post Information to Database Mod -->
	'U_MARK_ALWAYS_READ' => $mark_always_read,
//<!-- END Unread Post Information to Database Mod -->
'U_VIEW_FORUM' => $view_forum_url,
	'U_VIEW_OLDER_TOPIC' => $view_prev_topic_url,
	'U_VIEW_NEWER_TOPIC' => $view_next_topic_url,
	'U_POST_NEW_TOPIC' => $new_topic_url,
	'U_POST_EXPORT_TOPIC' => $export_topic_url,
	'U_WATCH_TOPIC' => $watch_topic_url,
	'U_POST_REPLY_TOPIC' => $reply_topic_url)
);

//
// Does this topic contain a poll?
//
if ( !empty($forum_topic_data['topic_vote']) )
{
	$s_hidden_fields = '';

	$sql = "SELECT vd.vote_id, vd.vote_text, vd.vote_start, vd.vote_length, vd.vote_max, vd.vote_voted, vd.vote_hide, vd.vote_tothide, vr.vote_option_id, vr.vote_option_text, vr.vote_result
		FROM " . VOTE_DESC_TABLE . " vd, " . VOTE_RESULTS_TABLE . " vr
		WHERE vd.topic_id = $topic_id
			AND vr.vote_id = vd.vote_id
		ORDER BY vr.vote_option_id ASC";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, "Could not obtain vote data for this topic", '', __LINE__, __FILE__, $sql);
	}

	if ( $vote_info = $db->sql_fetchrowset($result) )
	{
		$db->sql_freeresult($result);
		$vote_options = count($vote_info);

		$vote_id = $vote_info[0]['vote_id'];
		$vote_title = $vote_info[0]['vote_text'];
		$max_vote = $vote_info[0]['vote_max'];
		//$voted_vote = $vote_info[0]['vote_voted']; 
$sql = "SELECT DISTINCT vote_user_id 
FROM " . VOTE_USERS_TABLE . " 
WHERE vote_id = $vote_id"; 
if ( !($result = $db->sql_query($sql)) ) 
{ 
message_die(GENERAL_ERROR, "Could not count user vote data for this topic", '', __LINE__, __FILE__, $sql); 
} 
$voted_vote = $db->sql_numrows($result);

		$hide_vote = $vote_info[0]['vote_hide'];
		$tothide_vote = $vote_info[0]['vote_tothide'];

		$sql = "SELECT vote_id
			FROM " . VOTE_USERS_TABLE . "
			WHERE vote_id = $vote_id
				AND vote_user_id = " . intval($userdata['user_id']);
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, "Could not obtain user vote data for this topic", '', __LINE__, __FILE__, $sql);
		}

		$user_voted = ( $row = $db->sql_fetchrow($result) ) ? TRUE : 0;
		$db->sql_freeresult($result);

		if ( isset($HTTP_GET_VARS['vote']) || isset($HTTP_POST_VARS['vote']) )
		{
			$view_result = ( ( ( isset($HTTP_GET_VARS['vote']) ) ? $HTTP_GET_VARS['vote'] : $HTTP_POST_VARS['vote'] ) == 'viewresult' ) ? TRUE : 0;
		}
		else
		{
			$view_result = 0;
		}

		$poll_expired = ( $vote_info[0]['vote_length'] ) ? ( ( $vote_info[0]['vote_start'] + $vote_info[0]['vote_length'] < time() ) ? TRUE : 0 ) : 0;
if ( ( $poll_expired == 0 ) && ( $vote_info[0]['vote_length'] <> 0 ) )
			{
				$poll_expire_1 = (( $vote_info[0]['vote_start'] + $vote_info[0]['vote_length'] ) - time() );
				$poll_expire_2 = intval($poll_expire_1/86400);
				$poll_expire_a = $poll_expire_2*86400;
				$poll_expire_3 = intval(($poll_expire_1 - ($poll_expire_a))/3600);
				$poll_expire_b = $poll_expire_3*3600;
				$poll_expire_4 = intval((($poll_expire_1 - ($poll_expire_a) - ($poll_expire_b)))/60);
				$poll_comma = ', ';
				$poll_space = ' ';
				$poll_expire_2 == '0' ? $poll_expire_6='' : ( ( $poll_expire_3 == 0 && $poll_expire_4 == 0 ) ? $poll_expire_6=$poll_expire_2.$poll_space.$lang['Days'] : $poll_expire_6=$poll_expire_2.$poll_space.$lang['Days'].$poll_comma ) ;
				$poll_expire_3 == '0' ? $poll_expire_7='' : ( $poll_expire_4 == 0 ? $poll_expire_7=$poll_expire_3.$poll_space.$lang['Hours'] : $poll_expire_7=$poll_expire_3.$poll_space.$lang['Hours'].$poll_comma ) ;
				$poll_expire_4 == '0' ? $poll_expire_8='' : $poll_expire_8=$poll_expire_4.$poll_space.$lang['Minutes'] ;
				$poll_expires_d = $lang['Poll_expires'];
			}
			else
			{
				$poll_expires_6 = '';
				$poll_expires_7 = '';
				$poll_expires_8 = '';
				$poll_expires_d = '';
			}
			$voted_vote_nb = $voted_vote;
			$template->assign_vars(array(
				'VOTED_SHOW' => $lang['Voted_show'],
				'L_TOTAL_VOTES' => $total_votes_1,
				'L_RESULTS_AFTER' => $poll_expires_c,
				'L_POLL_EXPIRES' => $poll_expires_d,
				'POLL_EXPIRES' => ($poll_expire_6.$poll_expire_7.$poll_expire_8),
				'TOTAL_VOTES' => $total_votes_2)
			);

		if ( $user_voted || $view_result || $poll_expired || !$is_auth['auth_vote'] || $forum_topic_data['topic_status'] == TOPIC_LOCKED )
		{
			$template->set_filenames(array(
				'pollbox' => 'viewtopic_poll_result.tpl')
			);

			$vote_results_sum = 0;

			for($i = 0; $i < $vote_options; $i++)
			{
				$vote_results_sum += $vote_info[$i]['vote_result'];
			}

			$vote_graphic = 0;
			$vote_graphic_max = count($images['voting_graphic']);

			for($i = 0; $i < $vote_options; $i++)
			{
				$vote_percent = ( $vote_results_sum > 0 ) ? $vote_info[$i]['vote_result'] / $vote_results_sum : 0;
				$vote_graphic_length = round($vote_percent * $board_config['vote_graphic_length']);

				$vote_graphic_img = $images['voting_graphic'][$vote_graphic];
				$vote_graphic = ($vote_graphic < $vote_graphic_max - 1) ? $vote_graphic + 1 : 0;

				if ( count($orig_word) )
				{
					$vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']);
				}
				$hide_vote_bl = '';
				$hide_vote_zr = '0';
				$total_votes_1 = $lang['Total_votes'] ;
				$total_votes_2 = $vote_results_sum ;
				if ( ( $poll_expired == 0 ) && ( $hide_vote == 1 ) && ( $vote_info[0]['vote_length'] <> 0 ) )
				{
					if ( $tothide_vote == 1 )
					{
						$total_votes_1 = '' ;
						$total_votes_2 = '' ;
					}
					$poll_expires_c = $lang['Results_after'];
					$template->assign_block_vars("poll_option", array(
						'POLL_OPTION_CAPTION' => $vote_info[$i]['vote_option_text'],
						'POLL_OPTION_RESULT' => $hide_vote_bl,
						'POLL_OPTION_PERCENT' => $hide_vote_bl,
						'POLL_OPTION_IMG' => $vote_graphic_img,
						'POLL_OPTION_IMG_WIDTH' => $hide_vote_zr)
					);
				}
				else
				{
					$poll_expires_c = '';
					$template->assign_block_vars("poll_option", array(
						'POLL_OPTION_CAPTION' => $vote_info[$i]['vote_option_text'],
						'POLL_OPTION_RESULT' => $vote_info[$i]['vote_result'],
						'POLL_OPTION_PERCENT' => sprintf("%.1d%%", ($vote_percent * 100)),

						'POLL_OPTION_IMG' => $vote_graphic_img,
						'POLL_OPTION_IMG_WIDTH' => $vote_graphic_length)
					);
				}
			}

			if ( ( $poll_expired == 0 ) && ( $vote_info[0]['vote_length'] <> 0 ) )
			{
				$poll_expire_1 = (( $vote_info[0]['vote_start'] + $vote_info[0]['vote_length'] ) - time() );
				$poll_expire_2 = intval($poll_expire_1/86400);
				$poll_expire_a = $poll_expire_2*86400;
				$poll_expire_3 = intval(($poll_expire_1 - ($poll_expire_a))/3600);
				$poll_expire_b = $poll_expire_3*3600;
				$poll_expire_4 = intval((($poll_expire_1 - ($poll_expire_a) - ($poll_expire_b)))/60);
				$poll_comma = ', ';
				$poll_space = ' ';
				$poll_expire_2 == '0' ? $poll_expire_6='' : ( ( $poll_expire_3 == 0 && $poll_expire_4 == 0 ) ? $poll_expire_6=$poll_expire_2.$poll_space.$lang['Days'] : $poll_expire_6=$poll_expire_2.$poll_space.$lang['Days'].$poll_comma ) ;
				$poll_expire_3 == '0' ? $poll_expire_7='' : ( $poll_expire_4 == 0 ? $poll_expire_7=$poll_expire_3.$poll_space.$lang['Hours'] : $poll_expire_7=$poll_expire_3.$poll_space.$lang['Hours'].$poll_comma ) ;
				$poll_expire_4 == '0' ? $poll_expire_8='' : $poll_expire_8=$poll_expire_4.$poll_space.$lang['Minutes'] ;
				$poll_expires_d = $lang['Poll_expires'];
			}
			else
			{
				$poll_expires_6 = '';
				$poll_expires_7 = '';
				$poll_expires_8 = '';
				$poll_expires_d = '';
			}
			$voted_vote_nb = $voted_vote;
			$template->assign_vars(array(
				'VOTED_SHOW' => $lang['Voted_show'],
				'L_TOTAL_VOTES' => $total_votes_1,
				'L_RESULTS_AFTER' => $poll_expires_c,
				'L_POLL_EXPIRES' => $poll_expires_d,
				'POLL_EXPIRES' => ($poll_expire_6.$poll_expire_7.$poll_expire_8),
				'TOTAL_VOTES' => $total_votes_2)
			);

		}
		else
		{
			$template->set_filenames(array(
				'pollbox' => 'viewtopic_poll_ballot.tpl')
			);
			if ( $max_vote > 1 )
			{
				$vote_box = 'checkbox';
			}
			else 	$vote_box = 'radio';
			for($i = 0; $i < $vote_options; $i++)
			{
				if ( count($orig_word) )
				{
					$vote_info[$i]['vote_option_text'] = preg_replace($orig_word, $replacement_word, $vote_info[$i]['vote_option_text']);
				}

				$template->assign_block_vars("poll_option", array(
					'POLL_VOTE_BOX' => $vote_box,
					'POLL_OPTION_ID' => $vote_info[$i]['vote_option_id'],
					'POLL_OPTION_CAPTION' => $vote_info[$i]['vote_option_text'])
				);
			}

			$template->assign_vars(array(
				'L_SUBMIT_VOTE' => $lang['Submit_vote'],
				'L_VIEW_RESULTS' => $lang['View_results'],
                                'L_MUST_SELECT_POLL_OPTION' => $lang['No_vote_option'],

				'U_VIEW_RESULTS' => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id&amp;postdays=$post_days&amp;postorder=$post_order&amp;vote=viewresult"))
			);

			$s_hidden_fields = '<input type="hidden" name="topic_id" value="' . $topic_id . '" /><input type="hidden" name="mode" value="vote" />';
		}
		if ( $max_vote > 1 )
		{
			$vote_br = '<br>';
			$max_vote_nb = $max_vote;
		}
		else
		{
			$vote_br = '';
			$lang['Max_voting_1_explain'] = '';
			$lang['Max_voting_2_explain'] = '';
			$lang['Max_voting_3_explain'] = '';
			$max_vote_nb = '';
		}
		if ( count($orig_word) )
		{
			$vote_title = preg_replace($orig_word, $replacement_word, $vote_title);
		}

		$s_hidden_fields .= '<input type="hidden" name="sid" value="' . $userdata['session_id'] . '" />';

		$template->assign_vars(array(
			'POLL_QUESTION' => $vote_title,
			'POLL_VOTE_BR' => $vote_br,
			'MAX_VOTING_1_EXPLAIN' => $lang['Max_voting_1_explain'],
			'MAX_VOTING_2_EXPLAIN' => $lang['Max_voting_2_explain'],
			'MAX_VOTING_3_EXPLAIN' => $lang['Max_voting_3_explain'],
			'max_vote' => $max_vote_nb,
			'voted_vote' => $voted_vote_nb,

			'S_HIDDEN_FIELDS' => $s_hidden_fields,
			'S_POLL_ACTION' => append_sid("posting.$phpEx?mode=vote&amp;" . POST_TOPIC_URL . "=$topic_id"))
		);

		$template->assign_var_from_handle('POLL_DISPLAY', 'pollbox');
	}
}

init_display_post_attachments($forum_topic_data['topic_attachment']);
//
// Update the topic view counter
//
$sql = "UPDATE " . TOPICS_TABLE . "
	SET topic_views = topic_views + 1
	WHERE topic_id = $topic_id";
if ( !$db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, "Could not update topic views.", '', __LINE__, __FILE__, $sql);
}

// get the total post count - used for working out post percentages for users
$overall_total_posts = get_db_stat('postcount');

$translate_to = ($lang_equiv[$userdata['user_translations_lang']]) ? $lang_equiv[$userdata['user_translations_lang']] : $userdata['user_translations_lang'];

if (!$babelfish_lang_code[$translate_to] && !$intertran_lang_code[$translate_to])

{

	$translate_to = ($lang_equiv[$board_config['default_lang']]) ? $lang_equiv[$board_config['default_lang']] : $board_config['default_lang'];

}

$translate_to_img = '<img src="'.sprintf($images['icon_mini_translate'],$translate_to.'2').'"';

$script_name = preg_replace('/^\/?(.*?)\/?$/', '\1', trim($board_config['script_path'])). '/' . 'viewtopic_translate.'.$phpEx;

$server_name = trim($board_config['server_name']);

$server_protocol = ( $board_config['cookie_secure'] ) ? 'https://' : 'http://';

$server_port = ( $board_config['server_port'] <> 80 ) ? ':' . trim($board_config['server_port']) . '/' : '/';

$translate_url=$server_protocol . $server_name . $server_port . $script_name . '?' . POST_POST_URL . '=';

include($phpbb_root_path . 'includes/chinese.'.$phpEx);

//
// Okay, let's do the loop, yeah come on baby let's do the loop
// and it goes like this ...
//

// Start add - Birthday MOD
$this_year = create_date('Y', time(), $board_config['board_timezone']);
$this_date = create_date('md', time(), $board_config['board_timezone']);
// End add - Birthday MOD


for($i = 0; $i < $total_posts; $i++)
{
	$poster_id = $postrow[$i]['user_id'];
$post_id = $postrow[$i]['post_id'];

	$poster = ( $poster_id == ANONYMOUS ) ? $lang['Guest'] : $postrow[$i]['username'];
// Start add - Birthday MOD
	if ( $postrow[$i]['user_birthday'] != 999999 )
	{
		$poster_birthdate=realdate('md', $postrow[$i]['user_birthday']);
		$poster_age = $this_year - realdate ('Y',$postrow[$i]['user_birthday']);
		if ($this_date < $poster_birthdate) $poster_age--;
		$poster_age = $lang['Age'] . ': ' . $poster_age;
	} else
	{
		$poster_age = '';
	}
// End add - Birthday MOD
	$poster_uin = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['Member_uin'] . ': '. $postrow[$i]['user_id'] : '';
	if ( $postrow[$i]['user_birthday'] != 999999 )
	{
	$poster_birthdate=realdate('md', $postrow[$i]['user_birthday']);
		$n=0;
		while ($n<26)
		{
			if ($poster_birthdate>=$zodiacdates[$n] && $poster_birthdate<=$zodiacdates[$n+1])
			{
				$zodiac = $lang[$zodiacs[($n/2)]];
				$u_zodiac = $images[$zodiacs[($n/2)]];
				$zodiac_img = '<img src="' . $u_zodiac . '" alt="' . $zodiac . '" title="' . $zodiac . '" align="top" border="0" />';
				$n=26;
			} else
			{
				$n=$n+2;
			}
		}
	$poster_age = $this_year - realdate ('Y',$postrow[$i]['user_birthday']);
	if ($this_date < $poster_birthdate) $poster_age--;
	$poster_age = $lang['Age'] . ': ' . $poster_age;
	$chinese = get_chinese_year (realdate('Ymd', $postrow[$i]['user_birthday']));
	$u_chinese = $images[$chinese];
	$chinese_img = ($chinese=='Unknown') ? '' : '<img src="' . $u_chinese . '" alt="' . $lang[$chinese] . '" title="' . $lang[$chinese] . '" align="absmiddle" border="0" />';
	} else
	{
	$poster_age = '';
	$zodiac = '';
	$u_zodiac = '';
	$zodiac_img = '';
	$chinese = '';
	$u_chinese = '';
	$chinese_img = '';
	}

	$post_date = create_date($board_config['default_dateformat'], $postrow[$i]['post_time'], $board_config['board_timezone']);

	if ( $board_config['time_today'] < $postrow[$i]['post_time'])
	{
		$post_date = sprintf($lang['Today_at'], create_date($board_config['default_timeformat'], $postrow[$i]['post_time'], $board_config['board_timezone']));
	}
	else if ( $board_config['time_yesterday'] < $postrow[$i]['post_time'])
	{
		$post_date = sprintf($lang['Yesterday_at'], create_date($board_config['default_timeformat'], $postrow[$i]['post_time'], $board_config['board_timezone']));
	}
	$poster_posts = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['Posts'] . ': ' . $postrow[$i]['user_posts'] : '';

	
// Variable fr Lndernamen initialisieren: 
$sql = "SELECT flag_name FROM " . FLAG_TABLE . " WHERE flag_image = '" . $postrow[$i]['user_from_flag'] . "'"; 
if(!$result = $db->sql_query($sql)) { 
message_die(GENERAL_ERROR, "Kein Flaggenname hinterlegt!", "", __LINE__, __FILE__, $sql); 
} 
$country_flag = $db->sql_fetchrow($result); 
$country_flag_name = ucfirst($country_flag['flag_name']); 

// Variable fr Bundesland initialisieren: 
$sql = "SELECT flag_name FROM " . STATE_FLAG_TABLE . " WHERE flag_image = '" . $postrow[$i]['user_from_state_flag'] . "'"; 
if(!$result = $db->sql_query($sql)) { 
message_die(GENERAL_ERROR, "Kein Flaggenname hinterlegt!", "", __LINE__, __FILE__, $sql); 
} 
$state_flag = $db->sql_fetchrow($result); 
$state_flag_name = ucfirst($state_flag['flag_name']); 
// ENDE der Deklaration 

$poster_from = ( $postrow[$i]['user_from'] && $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['Location'] . ': ' . $postrow[$i]['user_from'] : '';$poster_from_flag = ( $postrow[$i]['user_from_flag'] && $postrow[$i]['user_id'] != ANONYMOUS ) ? "&nbsp;<img src=\"images/flags/" . $postrow[$i]['user_from_flag'] . "\" alt=\"" . $country_flag_name . "\" title=\"" . $country_flag_name . "\" border=\"0\" />" : ""; 
// STATEFLAGHACK-start 
$poster_from_state_flag = ( $postrow[$i]['user_from_state_flag'] && $postrow[$i]['user_id'] != ANONYMOUS ) ? "&nbsp;<img src=\"images/state_flags/" . $postrow[$i]['user_from_state_flag'] . "\" alt=\"" . $state_flag_name . "\" title=\"" . $state_flag_name . "\" border=\"0\" /><br />" : ""; 
// STATEFLAGHACK-end 





	$poster_joined = ( $postrow[$i]['user_id'] != ANONYMOUS ) ? $lang['Joined'] . ': ' . create_date($lang['DATE_FORMAT'], $postrow[$i]['user_regdate'], $board_config['board_timezone']) : '';
	$poster_avatar = '';
	if ( $postrow[$i]['user_avatar_type'] && $poster_id != ANONYMOUS && $postrow[$i]['user_allowavatar'] )

	{
		switch( $postrow[$i]['user_avatar_type'] )
		{
			case USER_AVATAR_UPLOAD:
				$poster_avatar = ( $board_config['allow_avatar_upload'] ) ? '<img src="' . $board_config['avatar_path'] . '/' . $postrow[$i]['user_avatar'] . '" alt="" border="0" />' : '';
				break;
			case USER_AVATAR_REMOTE:
				$poster_avatar = ( $board_config['allow_avatar_remote'] ) ? '<img src="' . $postrow[$i]['user_avatar'] . '" alt="" border="0" />' : '';
				break;
			case USER_AVATAR_GALLERY:
				$poster_avatar = ( $board_config['allow_avatar_local'] ) ? '<img src="' . $board_config['avatar_gallery_path'] . '/' . $postrow[$i]['user_avatar'] . '" alt="" border="0" />' : '';
				break;
		}
	}

	//
	// Default Avatar MOD - Begin
	//
	if ( empty($poster_avatar) && $poster_id != ANONYMOUS)
	{
		$poster_avatar = '<img src="'.  $images['default_avatar'] .'" alt="" border="0" />';
	}
	if ( $poster_id == ANONYMOUS )
	{
		$poster_avatar = '<img src="'.  $images['guest_avatar'] .'" alt="" border="0" />';
	}
	//
	// Default Avatar MOD - End
	//
	else {
		if ( $plus_config['default_avatar'] == 1)
		{
                        if ( $postrow[$i]['user_avatar'] == '' ) {
                                $poster_avatar = ( $board_config['allow_avatar_local'] ) ? '<img src="images/default_avatar.gif" alt="" border="0" />' : '';
                        }
          }}
// <!-- BEGIN Another Online/Offline indicator -->
	if ( !$postrow[$i]['user_allow_viewonline'] && $userdata['user_level'] == ADMIN || $postrow[$i]['user_allow_viewonline'] )
	{
		$current_time = time();
		$expiry_time = $current_time - 300;

		if ( $postrow[$i]['user_session_time'] >= $expiry_time )
		{
			$user_onlinestatus = '<img src="' . $images['Online'] . '" alt="' . $lang['Online'] . '" title="' . $lang['Online'] . '" border="0"  />';

			if ( !$postrow[$i]['user_allow_viewonline'] && $userdata['user_level'] == ADMIN )
			{
				$user_onlinestatus = '<img src="' . $images['Hidden_Admin'] . '" alt="' . $lang['Hidden'] . '" title="' . $lang['Hidden'] . '" border="0"  />';
			}
		}
		else
		{
			$user_onlinestatus = '<img src="' . $images['Offline'] . '" alt="' . $lang['Offline'] . '" title="' . $lang['Offline'] . '" border="0" />';

			if ( !$postrow[$i]['user_allow_viewonline'] && $userdata['user_level'] == ADMIN )
			{
				$user_onlinestatus = '<img src="' . $images['Offline'] . '" alt="' . $lang['Hidden'] . '" title="' . $lang['Hidden'] . '" border="0" />';
			}
		}
	}
	else
	{
		$user_onlinestatus = '<img src="' . $images['Offline'] . '" alt="' . $lang['Offline'] . '" title="' . $lang['Offline'] . '" border="0" />';
	}
	if ( $postrow[$i]['user_id'] == -1 )
	  {
		  $user_onlinestatus = '';
	  }
// <!-- END Another Online/Offline indicator -->
	//
	// Define the little post icon
	//
//<!-- BEGIN Unread Post Information to Database Mod -->	
	if( !$userdata['upi2db_access'])
	{
//<!-- END Unread Post Information to Database Mod -->
	if ( $userdata['session_logged_in'] && $postrow[$i]['post_time'] > $userdata['user_lastvisit'] && $postrow[$i]['post_time'] > $topic_last_read )
	{
		$mini_post_img = $images['icon_minipost_new'];
		$mini_post_alt = $lang['New_post'];
	}
	else
	{
		$mini_post_img = $images['icon_minipost'];
		$mini_post_alt = $lang['Post'];
	}
//<!-- BEGIN Unread Post Information to Database Mod -->	
    }
    else
    {
        viewtopic_calc_unread($unread, $topic_id, $postrow[$i]['post_id'], $forum_id, 

$mini_post_img, $mini_post_alt, $unread_color, $read_posts);
    }
//<!-- END Unread Post Information to Database Mod -->
	$mini_post_url = append_sid("viewtopic.$phpEx?" . POST_POST_URL . '=' . $postrow[$i]['post_id']) . '#' . $postrow[$i]['post_id'];

	//
	// Generate ranks, set them to empty string initially.
	//
	$poster_rank = '';
	$rank_image = '';
        $gender_image = '';

	if ( $postrow[$i]['user_id'] == ANONYMOUS )
	{
	}
	else if ( $postrow[$i]['user_rank'] )
	{
		for($j = 0; $j < count($ranksrow); $j++)
		{
			if ( $postrow[$i]['user_rank'] == $ranksrow[$j]['rank_id'] && $ranksrow[$j]['rank_special'] )
			{
				$poster_rank = $ranksrow[$j]['rank_title'];
				$rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $images['rank_path'] . $ranksrow[$j]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';


			}
		}
	}
	else
	{
		for($j = 0; $j < count($ranksrow); $j++)
		{
			if ( $postrow[$i]['user_posts'] >= $ranksrow[$j]['rank_min'] && !$ranksrow[$j]['rank_special'] )
			{
				$poster_rank = $ranksrow[$j]['rank_title'];
				$rank_image = ( $ranksrow[$j]['rank_image'] ) ? '<img src="' . $images['rank_path'] . $ranksrow[$j]['rank_image'] . '" alt="' . $poster_rank . '" title="' . $poster_rank . '" border="0" /><br />' : '';


			}
		}
	}


	//
	// Handle anon users posting with usernames
	//
	if ( $poster_id == ANONYMOUS && $postrow[$i]['post_username'] != '' )
	{
		$poster = $postrow[$i]['post_username'];
		$poster_rank = $lang['Guest'];
	// Start add - Birthday MOD
		$poster_age = '';
	// End add - Birthday MOD
	}

	$temp_url = '';

	if ( $poster_id != ANONYMOUS )
	{
		$temp_url = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$poster_id");
		$profile_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_profile'] . '" alt="' . $lang['Read_profile'] . '" title="' . $lang['Read_profile'] . '" border="0" /></a>';
		$profile = '<a href="' . $temp_url . '">' . $lang['Read_profile'] . '</a>';

		$temp_url = append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=$poster_id");
		$pm_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_pm'] . '" alt="' . $lang['Send_private_message'] . '" title="' . $lang['Send_private_message'] . '" border="0" /></a>';
		switch ($postrow[$i]['user_gender'])
		{
			case 1 : $gender_image = "<img src=\"" . $images['icon_minigender_male'] . "\" alt=\"" . $lang['Gender'].  ":".$lang['Male']."\" title=\"" . $lang['Gender'] . ":".$lang['Male']. "\" border=\"0\" />"; break;
			case 2 : $gender_image = "<img src=\"" . $images['icon_minigender_female'] . "\" alt=\"" . $lang['Gender']. ":".$lang['Female']. "\" title=\"" . $lang['Gender'] . ":".$lang['Female']. "\" border=\"0\" />"; break;
			default : $gender_image="";
		}
		$pm = '<a href="' . $temp_url . '">' . $lang['Send_private_message'] . '</a>';
		$temp_url = append_sid("album.$phpEx?user_id=$poster_id");
		$gallery_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_gallery'] . '" alt="' . sprintf($lang['Personal_Gallery_Of_User'], $postrow[$i]['username']) . '" title="' . sprintf($lang['Personal_Gallery_Of_User'], $postrow[$i]['username']) . '" border="0" /></a>';
		$gallery = '<a href="' . $temp_url . '">' . $lang['Album'] . '</a>';
                if ( !empty($postrow[$i]['user_viewemail']) || $is_auth['auth_mod'] )

		{
			$email_nospam = str_replace( "@", $lang['e-mail_sbf_at'], $postrow[$i]['user_email']);
			$email_nospam = str_replace( ".", $lang['e-mail_sbf_dot'], $email_nospam);

			$email_uri = ( $board_config['board_email_form'] ) ? append_sid("profile.$phpEx?mode=email&amp;" . POST_USERS_URL .'=' . $poster_id) : 'mailto:' . $email_nospam;

			$email_img = '<a href="' . $email_uri . '"><img src="' . $images['icon_email'] . '" alt="' . $lang['Send_email'] . '" title="' . $lang['Send_email'] . '" border="0" /></a>';
			$email = '<a href="' . $email_uri . '">' . $lang['Send_email'] . '</a>';
		}
		else
		{
			$email_img = '';
			$email = '';
		}

		$www_img = ( $postrow[$i]['user_website'] ) ? '<a href="' . $postrow[$i]['user_website'] . '" target="_userwww"><img src="' . $images['icon_www'] . '" alt="' . $lang['Visit_website'] . '" title="' . $lang['Visit_website'] . '" border="0" /></a>' : '';
		$www = ( $postrow[$i]['user_website'] ) ? '<a href="' . $postrow[$i]['user_website'] . '" target="_userwww">' . $lang['Visit_website'] . '</a>' : '';

		if ( !empty($postrow[$i]['user_icq']) )
		{
			$icq_status_img = '<a href="http://wwp.icq.com/' . $postrow[$i]['user_icq'] . '#pager"><img src="http://web.icq.com/whitepages/online?icq=' . $postrow[$i]['user_icq'] . '&img=5" width="18" height="18" border="0" /></a>';
			$icq_img = '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $postrow[$i]['user_icq'] . '"><img src="' . $images['icon_icq'] . '" alt="' . $lang['ICQ'] . '" title="' . $lang['ICQ'] . '" border="0" /></a>';
			$icq =  '<a href="http://wwp.icq.com/scripts/search.dll?to=' . $postrow[$i]['user_icq'] . '">' . $lang['ICQ'] . '</a>';
		}
		else
		{
			$icq_status_img = '';
			$icq_img = '';
			$icq = '';
		}

		$aim_img = ( $postrow[$i]['user_aim'] ) ? '<a href="aim:goim?screenname=' . $postrow[$i]['user_aim'] . '&amp;message=Hello+Are+you+there?"><img src="' . $images['icon_aim'] . '" alt="' . $lang['AIM'] . '" title="' . $lang['AIM'] . '" border="0" /></a>' : '';
		$aim = ( $postrow[$i]['user_aim'] ) ? '<a href="aim:goim?screenname=' . $postrow[$i]['user_aim'] . '&amp;message=Hello+Are+you+there?">' . $lang['AIM'] . '</a>' : '';

		$temp_url = append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=$poster_id");
		$msn_img = ( $postrow[$i]['user_msnm'] ) ? '<a href="' . $temp_url . '"><img src="' . $images['icon_msnm'] . '" alt="' . $lang['MSNM'] . '" title="' . $lang['MSNM'] . '" border="0" /></a>' : '';
		$msn = ( $postrow[$i]['user_msnm'] ) ? '<a href="' . $temp_url . '">' . $lang['MSNM'] . '</a>' : '';
            $skype = ( $postrow[$i]['user_skype'] ) ? '<a href="#'.$postrow[$i]['post_id'].'" onClick=window.open("skype.'.$phpEx.'?u='.$poster_id.'","gesamt","location=no,menubar=no,toolbar=no,scrollbars=auto,width=320,height=500,status=no",title="Skype")><img src="' . $images['icon_skype'] . '" alt="' . $lang['skype'] . '" title="' . $lang['skype'] . '" border="0" /></a>' : '';
		$yim_img = ( $postrow[$i]['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $postrow[$i]['user_yim'] . '&amp;.src=pg"><img src="' . $images['icon_yim'] . '" alt="' . $lang['YIM'] . '" title="' . $lang['YIM'] . '" border="0" /></a>' : '';
		$yim = ( $postrow[$i]['user_yim'] ) ? '<a href="http://edit.yahoo.com/config/send_webmesg?.target=' . $postrow[$i]['user_yim'] . '&amp;.src=pg">' . $lang['YIM'] . '</a>' : '';
		$regdate = $postrow[$i]['user_regdate'];
		$user_posts = $postrow[$i]['user_posts'];
		$memberdays = max(1, round( ( time() - $regdate ) / 86400 ));
		$posts_per_day = $user_posts / $memberdays;

		// Get the users percentage of total posts
		if ( $postrow[$i]['user_posts'] != 0  )
		{
		   $percentage = ( $overall_total_posts ) ? min(100, ($user_posts / $overall_total_posts) * 100) : 0;
		}
		else
		{
		   $percentage = 0;
		}
		$post_day_stats = sprintf($lang['User_post_day_stats'], $posts_per_day);
		$post_percent_stats = sprintf($lang['User_post_pct_stats'], $percentage);

	}
	else
	{
		$profile_img = '';
		$profile = '';
		$pm_img = '';
		$pm = '';
		$gallery_img = '';
		$gallery = '';
		$email_img = '';
		$email = '';
		$www_img = '';
		$www = '';
		$icq_status_img = '';
		$icq_img = '';
		$icq = '';
		$aim_img = '';
		$aim = '';
		$msn_img = '';
		$msn = '';
            $skype = '';
		$yim_img = '';
		$yim = '';
		$post_day_stats = '';
		$post_percent_stats = '';
	}

	$temp_url = append_sid("posting.$phpEx?mode=quote&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']);
	$quote_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_quote'] . '" alt="' . $lang['Reply_with_quote'] . '" title="' . $lang['Reply_with_quote'] . '" border="0" /></a>';
	$quote = '<a href="' . $temp_url . '">' . $lang['Reply_with_quote'] . '</a>';

	$temp_url = append_sid("search.$phpEx?search_author=" . urlencode($postrow[$i]['username']) . "&amp;showresults=posts");
	$search_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_search'] . '" alt="' . sprintf($lang['Search_user_posts'], $postrow[$i]['username']) . '" title="' . sprintf($lang['Search_user_posts'], $postrow[$i]['username']) . '" border="0" /></a>';
	$search = '<a href="' . $temp_url . '">' . sprintf($lang['Search_user_posts'], $postrow[$i]['username']) . '</a>';


	if ( ( $userdata['user_id'] == $poster_id && $is_auth['auth_edit'] && $forum_topic_data['topic_last_post_id'] == $postrow[$i]['post_id'] ) || $is_auth['auth_mod'] ) 
	{ 
		$temp_url = append_sid("posting.$phpEx?mode=editpost&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id']); 
		$edit_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_edit'] . '" alt="' . $lang['Edit_delete_post'] . '" title="' . $lang['Edit_delete_post'] . '" border="0" /></a>'; 
		$edit = '<a href="' . $temp_url . '">' . $lang['Edit_delete_post'] . '</a>'; 
	} 
	else
	{
		$edit_img = '';
		$edit = '';
	}
	// Start add - Who viewed a topic MOD
	$topic_view_img = ($userdata['session_logged_in']) ? ' <a href="' . append_sid("topic_view_users.$phpEx?".POST_TOPIC_URL."=$topic_id") . '"><img src="' . $images['icon_view'] . '" alt="' . $lang['Topic_view_users'] . '" title="' . $lang['Topic_view_users'] . '" border="0" /></a>':'';
	// End add - Who viewed a topic MOD

	if ( $is_auth['auth_mod'] )
	{
		$temp_url = "modcp.$phpEx?mode=ip&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id'] . "&amp;" . POST_TOPIC_URL . "=" . $topic_id . "&amp;sid=" . $userdata['session_id'];
		$ip_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_ip'] . '" alt="' . $lang['View_IP'] . '" title="' . $lang['View_IP'] . '" border="0" /></a>';
		$ip = '<a href="' . $temp_url . '">' . $lang['View_IP'] . '</a>';

		$temp_url = "posting.$phpEx?mode=delete&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id'] . "&amp;sid=" . $userdata['session_id'];
		$delpost_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_delpost'] . '" alt="' . $lang['Delete_post'] . '" title="' . $lang['Delete_post'] . '" border="0" /></a>';
		$delpost = '<a href="' . $temp_url . '">' . $lang['Delete_post'] . '</a>';
	}
	else
	{
		$ip_img = '';
		$ip = '';

		if ( $userdata['user_id'] == $poster_id && $is_auth['auth_delete'] && $forum_topic_data['topic_last_post_id'] == $postrow[$i]['post_id'] )
		{
			$temp_url = "posting.$phpEx?mode=delete&amp;" . POST_POST_URL . "=" . $postrow[$i]['post_id'] . "&amp;sid=" . $userdata['session_id'];
			$delpost_img = '<a href="' . $temp_url . '"><img src="' . $images['icon_delpost'] . '" alt="' . $lang['Delete_post'] . '" title="' . $lang['Delete_post'] . '" border="0" /></a>';
			$delpost = '<a href="' . $temp_url . '">' . $lang['Delete_post'] . '</a>';
		}
		else
		{
			$delpost_img = '';
			$delpost = '';
		}
	}
	if($poster_id != ANONYMOUS && $postrow[$i]['user_level'] != ADMIN)
	{
		$current_user = str_replace("'","\'",$postrow[$i]['username']);
		if ($is_auth['auth_greencard'])
		{
		      $g_card_img = '&nbsp;<input type="image" name="unban" value="unban" onClick="return confirm(\''.sprintf($lang['Green_card_warning'],$current_user).'\')" src="'. $images['icon_g_card'] . '" alt="' . $lang['Give_G_card'] . '" >';
		}
		else
		{
			$g_card_img = '';
		}
		$user_warnings = $postrow[$i]['user_warnings'];
		$card_img = ($user_warnings) ? (( $user_warnings < $board_config['max_user_bancard']) ? sprintf($lang['Warnings'], $user_warnings) : $lang['Banned'] ) : '';
		// these lines will make a icon apear beside users post, if user have warnings or ar banned
		// used instead of the previous line of code, witch shows the status as a text
		//  ------ From here --- do not include this line
		// $card_img = ($user_warnings) ? '<img src="'.(( $user_warnings < $board_config['max_user_bancard']) ?
		//		$images['icon_y_card'] . '" alt="'. sprintf($lang['Warnings'], $user_warnings) .'">' :
		//		$images['icon_r_card'] . '" alt="'. $lang['Banned'] .'">') : '';
		//  ----- To this line --- Do not included this line
		//
		// You may also included several images, instead of only one yellow, these lines below will produce several yellow images, depending on mumber of yellow cards
		//  ------ From here --- do not include this line
		//$card_img = ($user_warnings >= $board_config['max_user_bancard'])  ? '<img src="'.$images['icon_r_card'] . '" alt="'. $lang['Banned'] .'">' : '';
		//for ($n=0 ; $n<$user_warnings && $user_warnings < $board_config['max_user_bancard'];$n++)
		//{
		//$card_img .= ($user_warnings) ? '<img src="'.(( $user_warnings < $board_config['max_user_bancard']) ?
		//$images['icon_y_card'] . '" alt="'. sprintf($lang['Warnings'], $user_warnings) .'">' :
		//$images['icon_r_card'] . '" alt="'. $lang['Banned'] .'">') : '';
		//}
		//  ----- To this line --- Do not included this line

		if ($user_warnings<$board_config['max_user_bancard'] && $is_auth['auth_ban'] )
		{
			$y_card_img = '&nbsp;<input type="image" name="warn" value="warn" onClick="return confirm(\''.sprintf($lang['Yellow_card_warning'],$current_user).'\')" src="'. $images['icon_y_card'] . '" alt="' . sprintf($lang['Give_Y_card'],$user_warnings+1) . '" >';
			$r_card_img = '&nbsp;<input type="image" name="ban" value="ban"  onClick="return confirm(\''.sprintf($lang['Red_card_warning'],$current_user).'\')" src="'. $images['icon_r_card'] . '" alt="' . $lang['Give_R_card'] . '" >';
		}
		else
		{
			$y_card_img = '';
			$r_card_img = '';
		}
	}
	else
	{
		$card_img = '';
		$g_card_img = '';
		$y_card_img = '';
		$r_card_img = '';
	}

	if ($is_auth['auth_bluecard'])
	{
		if ($is_auth['auth_mod'])
		{
			$b_card_img = (($postrow[$i]['post_bluecard'])) ? '&nbsp;<input type="image" name="report_reset" value="report_reset" onClick="return confirm(\''.$lang['Clear_blue_card_warning'].'\')" src="'. $images['icon_bhot_card'] . '" alt="'. sprintf($lang['Clear_b_card'],$postrow[$i]['post_bluecard']) . '">':'&nbsp;<input type="image" name="report" value="report" onClick="return confirm(\''.$lang['Blue_card_warning'].'\')" src="'. $images['icon_b_card'] . '" alt="'. $lang['Give_b_card'] . '" >';
		}
   		else
		{
			$b_card_img = '&nbsp;<input type="image" name="report" value="report" src="'. $images['icon_b_card'] . '" alt="'. $lang['Give_b_card'] . '" >';
   		}
	}
	else $b_card_img = '';

	// parse hidden filds if cards visible
	$card_hidden = ($g_card_img || $r_card_img || $y_card_img || $b_card_img) ? '<input type="hidden" name="post_id" value="'. $postrow[$i]['post_id'].'">' :'';
	$post_subject = ( $postrow[$i]['post_subject'] != '' ) ? $postrow[$i]['post_subject'] : '';
$post_extra = ( $postrow[$i]['post_extra'] != '' ) ? '<b>'.$lang['Extra'].': </b> '.$postrow[$i]['post_extra'] : '';

	// CrackerTracker v5.x
	if ( $postrow[$i]['ct_miserable_user'] == 1 && $postrow[$i]['user_id'] != $userdata['user_id'] && $userdata['user_level'] == 0)
	{
		$message = $lang['ctracker_message_dialog_title'] . '<br /><br />' . $lang['ctracker_ipb_deleted'];
	}
	else
	{
		// Cache Posts
	$parsed = ($board_config['enable_post_cache']) ? $postrow[$i]['parsed'] : 0;
	if (!$parsed || !$board_config['enable_post_cache'])
	{
		$message = $postrow[$i]['post_text'];
	} else {
		$cstyle = ($userdata['session_logged_in'] && $userdata['user_style'] != $board_config['default_style'] && $board_config['cache_each_template']) ? $userdata['user_style'].'_' : '';
		$cachefile = 'cache/posts/'.$cstyle.'post_'.$postrow[$i]['post_id'].'.gz';
		if (file_exists($cachefile) && filemtime($cachefile) >= $postrow[$i]['post_edit_time'] && $postrow[$i]['cache_file_md5'] == md5_file($cachefile))
		{
			$handle = @fopen($phpbb_root_path.$cachefile, 'r');
			$message = gzinflate(@fread($handle, @filesize($cachefile)+1));
			@fclose($handle);
		} else {
			foreach (glob($phpbb_root_path.'cache/posts/*post_'.$postrow[$i]['post_id'].'.gz') as $cachefile)
			{
				@unlink($cachefile);
			}
			$message = $postrow[$i]['post_text'];
			$parsed = 0;
		}
	}
// Cache Posts
//	$message = $postrow[$i]['post_text'];
		if ( $postrow[$i]['ct_miserable_user'] == 1 && $userdata['user_level'] == ADMIN )
		{
			$message .= '<br /><br />' . $lang['ctracker_mu_success'];
		}
	}
	$bbcode_uid = $postrow[$i]['bbcode_uid'];

	$user_sig = ( $postrow[$i]['enable_sig'] && $postrow[$i]['user_sig'] != '' && $board_config['allow_sig'] ) ? $postrow[$i]['user_sig'] : '';

	$user_sig_bbcode_uid = $postrow[$i]['user_sig_bbcode_uid'];
	if ( $show_sig != '1' ) { $user_sig = '' ; }

	//
	// Note! The order used for parsing the message _is_ important, moving things around could break any
	// output
	//

	//
	// If the board has HTML off but the post has HTML
	// on then we process it, else leave it alone
	//
	if ( !$board_config['allow_html'] || !$userdata['user_allowhtml'])
	{
		if ( $user_sig != '' )
		{
			$user_sig = preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $user_sig);
		}

		// Cache Posts
		if (!$parsed || !$board_config['enable_post_cache'])
		{
			if ( $postrow[$i]['enable_html'] )
			{
				$message = preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $message);
			}
		}
		// Cache Posts
/*		if ( $postrow[$i]['enable_html'] )
		{
			$message = preg_replace('#(<)([\/]?.*?)(>)#is', "&lt;\\2&gt;", $message);
		}*/
	}

	//
	// Parse message and/or sig for BBCode if reqd
	//
	if ($user_sig != '' && $user_sig_bbcode_uid != '')
	{

			$user_sig = ($board_config['allow_bbcode']) ? bbencode_second_pass($user_sig, $user_sig_bbcode_uid) : preg_replace("/\:$user_sig_bbcode_uid/si", '', $user_sig);
	}

	// Cache Posts
		if (!$parsed || !$board_config['enable_post_cache'])
		{
			if ( $bbcode_uid != '' )
			{
				$message = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($message, $bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $message);
			}
		}
		// Cache Posts
/*		if ( $bbcode_uid != '' )
		{
			$message = ( $board_config['allow_bbcode'] ) ? bbencode_second_pass($message, $bbcode_uid) : preg_replace('/\:[0-9a-z\:]+\]/si', ']', $message);
		}*/


	if ( $user_sig != '' )
	{
		$user_sig = make_clickable($user_sig);
	}
	(!$parsed || !$board_config['enable_post_cache']) ? $message = make_clickable($message) : ''; // Cache Posts
//	$message = make_clickable($message);

	//
	// Parse smilies
	//
	if ( $board_config['allow_smilies'] )
	{
$access_level = smilies_access();
		if ( $postrow[$i]['user_allowsmile'] && $user_sig != '' )
		{
			$user_sig = smilies_pass($user_sig);
		}

		(!$parsed || !$board_config['enable_post_cache']) ? (($postrow[$i]['enable_smilies']) ? $message = smilies_pass($message) : '') : ''; // Cache Posts
/*		if ( $postrow[$i]['enable_smilies'] )
		{
			$message = smilies_pass($message);
		}*/
	}
// Cache Posts
	if (!$parsed && $board_config['enable_post_cache'] && ($postrow[$i]['enable_bbcode'] || $postrow[$i]['enable_html']) && !$postrow[$i]['dont_cache'] && !$forum_topic_data['topic_cache_lock'])
	{
		$cstyle = ($userdata['session_logged_in'] && $userdata['user_style'] != $board_config['default_style'] && $board_config['cache_each_template']) ? $userdata['user_style'].'_' : '';
		$cachefile = 'cache/posts/'.$cstyle.'post_'.$postrow[$i]['post_id'].'.gz';
		$handle = @fopen($phpbb_root_path.$cachefile, 'w');
		@flock($handle, LOCK_EX);
		$packed = gzdeflate($message, 9);
		$cf_size = @fwrite($handle, $packed);
		@flock($handle, LOCK_UN);
		@fclose($handle);
		@chmod($phpbb_root_path.$cachefile, 0666);

		if ($cf_size)
		{
			if ($cf_size > $board_config['min_post_cache_size'])
			{
				$parsed = 1;
				$sql = "UPDATE " . POSTS_TABLE . "
					SET parsed = 1, cache_file_md5 = '".md5_file($cachefile)."'
					WHERE post_id = ".$postrow[$i]['post_id'];
				if(!$result = $db->sql_query($sql))
				{
					message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
				}
			}
			else
			{
				$parsed = 0;
				$postrow[$i]['dont_cache'] = 1;
				foreach (glob($phpbb_root_path.'cache/posts/*post_'.$postrow[$i]['post_id'].'.gz') as $cachefile)
				{
					@unlink($cachefile);
				}
				$sql = "UPDATE " . POSTS_TABLE . "
					SET parsed = 0, dont_cache = 1, cache_file_md5 = NULL 
					WHERE post_id = ".$postrow[$i]['post_id'];
				if(!$result = $db->sql_query($sql))
				{
					message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
				}
			}
		}
		else if ($postrow[$i]['parsed'])
		{
			$parsed = 0;
			$sql = "UPDATE " . POSTS_TABLE . "
				SET parsed = 0, cache_file_md5 = NULL 
				WHERE post_id = ".$postrow[$i]['post_id'];
			if(!$result = $db->sql_query($sql))
			{
				message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
			}
		}
		$postrow[$i]['parsed'] = $parsed;
	}
	else if ( $forum_topic_data['topic_cache_lock'] )
	{
		$parsed = 0;
		$postrow[$i]['dont_cache'] = 1;
		$sql = "UPDATE " . POSTS_TABLE . "
			SET parsed = 0, dont_cache = 1, cache_file_md5 = NULL 
			WHERE post_id = ".$postrow[$i]['post_id'];
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, 'Could not update parse info', '', __LINE__, __FILE__, $sql);
		}
		$postrow[$i]['parsed'] = $parsed;
	}
	if ($board_config['enable_post_cache'])
	{
		$parse_status = ($parsed) ? $CPS_Indicator['cached'] : (($postrow[$i]['dont_cache']) ? $CPS_Indicator['dont_cache'] : ((!$postrow[$i]['enable_bbcode'] && !$postrow[$i]['enable_html']) ? $CPS_Indicator['not_cached'] : $CPS_Indicator['error']));
		$cps_img = (!$forum_topic_data['topic_cache_lock']) ? '<a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=recycle&amp;'.POST_POST_URL.'='.$postrow[$i]['post_id'].'&amp;'.POST_TOPIC_URL.'='.$postrow[$i]['topic_id'].'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_recycle'].'" alt="'.$lang['CPS_recycle'].'" title="'.$lang['CPS_recycle'].'" border="0" /></a>' : '';
		$cps_img .= ($parsed) ? ' <a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=deactivate&amp;'.POST_POST_URL.'='.$postrow[$i]['post_id'].'&amp;'.POST_TOPIC_URL.'='.$postrow[$i]['topic_id'].'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_deactivate'].'" alt="'.$lang['CPS_dont_cache'].'" title="'.$lang['CPS_dont_cache'].'" border="0" /></a>' : '';
	} else {
		$parse_status = ($postrow[$i]['parsed']) ? $CPS_Indicator['off_but_cached'] : $CPS_Indicator['off'] ;
		$cps_img = ($postrow[$i]['parsed'] && $userdata['user_level'] == ADMIN) ? '<a href="modcp.'.$phpEx.'?'.POST_CPS_MANAGE_URL.'=delete&amp;'.POST_POST_URL.'='.$postrow[$i]['post_id'].'&amp;'.POST_TOPIC_URL.'='.$postrow[$i]['topic_id'].'&amp;sid='.$userdata['session_id'].'"><img src="'.$images['icon_cache_delete'].'" alt="'.$lang['CPS_delete'].'" title="'.$lang['CPS_delete'].'" border="0" /></a>' : '';
	}
// Cache Posts
	//
	// Highlight active words (primarily for search)
	//
	if ($highlight_match)
	{
		// This has been back-ported from 3.0 CVS
		$message = preg_replace('#(?!<.*)(?<!\w)(' . $highlight_match . ')(?!\w|[^<>]*>)#i', '<b style="color:#'.$theme['fontcolor3'].'">\1</b>', $message);



	}

	//
	// Replace naughty words
	//
	if (count($orig_word))
	{
		$post_subject = preg_replace($orig_word, $replacement_word, $post_subject);
$post_extra = preg_replace($orig_word, $replacement_word, $post_extra);

		if ($user_sig != '')
		{
			$user_sig = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $user_sig . '<'), 1, -1));


		}

		$message = str_replace('\"', '"', substr(@preg_replace('#(\>(((?>([^><]+|(?R)))*)\<))#se', "@preg_replace(\$orig_word, \$replacement_word, '\\0')", '>' . $message . '<'), 1, -1));
				
	}

	//
	// Replace newlines (we use this rather than nl2br because
	// till recently it wasn't XHTML compliant)
	//
	if ( $user_sig != '' )
	{

		$user_sig = '<br />_________________<br />' . str_replace("\n", "\n<br />\n", $user_sig);
	}

	$message = str_replace("\n", "\n<br />\n", $message);

	//
	// Editing information
	//
	$sql = "SELECT pe.*, u.username
			FROM " . POSTS_EDIT_TABLE . " pe, " . USERS_TABLE . " u
			WHERE pe.post_id = " . $postrow[$i]['post_id'] . "
				AND pe.user_id = u.user_id
			ORDER BY pe.post_edit_time DESC";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not obtain posts edit count information', '', __LINE__, __FILE__, $sql);
	}

	$l_edited_by = '';
	while ( $row = $db->sql_fetchrow($result) )
	{
		$l_edit_time_total = ( $row['post_edit_count'] == 1 ) ? $lang['Edited_time_total'] : $lang['Edited_times_total'];
		$l_edited_by .= ( ($l_edited_by == '') ? '<br />' : '' ) . '<br />' . sprintf($l_edit_time_total, $row['username'], create_date($board_config['default_dateformat'], $row['post_edit_time'], $board_config['board_timezone']), $row['post_edit_count']);
	}

	// Start add - Translate posts MOD
if (!empty($translate_to) && $userdata['user_id']!=$poster_id)
{
	$translate_from = ($lang_equiv[$board_config['real_default_lang']]) ? $lang_equiv[$board_config['real_default_lang']] : $board_config['real_default_lang'];
	$translate_from = ($babelfish_lang_code[$translate_from]) ? $translate_from : '';
	if (!empty($translate_from) && $translate_to!=$translate_from && $babelfish_available[$babelfish_lang_code[$translate_from].'_'.$babelfish_lang_code[$translate_to]]=='yes')
	{	
		if ( $lang['need_pronouns'] == 'yes' )
		{
			$l_translate = sprintf($lang['translate_tooltip'],$lang[$translate_from][1].$lang[$translate_from][0],$lang[$translate_to][2].$lang[$translate_to][0]);
		} else
		{
			$l_translate = sprintf($lang['translate_tooltip'],$lang[$translate_from],$lang[$translate_to]);
		}
		$translate_from_img = '<img src="'.sprintf($images['icon_mini_translate'],$translate_from.'1').'"';
		$translate_link = '<a href="http://babelfish.altavista.com/babelfish/trurl_pagecontent?lp=' . $babelfish_lang_code[$translate_from] . '_' . $babelfish_lang_code[$translate_to] . '&url=' . urlencode($translate_url.$post_id.'&sid='.$userdata['session_id']) . '" target="_blanc">';
		$translate_link .=$translate_from_img.' alt="' . $l_translate. '" title="' . $l_translate. '" border="0" />'.$translate_to_img.'alt="' . $l_translate. '" title="' . $l_translate. '" border="0" /></a>';
	} else
	{
		$translate_from = ($lang_equiv[$board_config['real_default_lang']]) ? $lang_equiv[$board_config['real_default_lang']] : $board_config['real_default_lang'];
		$translate_from = ($intertran_lang_code[$translate_from] && $translate_from!='romanian') ? $translate_from : '';
		if (!empty($translate_from) && $translate_to!=$translate_from)
		{	
			if ( $lang['need_pronouns'] == 'yes' )
			{
				$l_translate = sprintf($lang['translate_tooltip'],$lang[$translate_from][1].$lang[$translate_from][0],$lang[$translate_to][2].$lang[$translate_to][0]);
			} else
			{
				$l_translate = sprintf($lang['translate_tooltip'],$lang[$translate_from],$lang[$translate_to]);
			}
			$translate_from_img = '<img src="'.sprintf($images['icon_mini_translate'],$translate_from.'1').'"';
			$translate_link = '<a href="http://intertran.tranexp.com/Translate/index.shtml?' . 'from=' . $intertran_lang_code[$translate_from] . '&to=' . $intertran_lang_code[$translate_to] . '&type=url&url=' . urlencode($translate_url.$post_id.'&sid='.$userdata['session_id'].'#'.$post_id) . '" target="_blanc">';
			$translate_link .=$translate_from_img.' alt="' . $l_translate. '" title="' . $l_translate. '" border="0" />'.$translate_to_img.'alt="' . $l_translate. '" title="' . $l_translate. '" border="0" /></a>';
		} else
		{
			$translate_link = ' ';
		}
	}

	$translate_from2 = ($lang_equiv[$postrow[$i]['user_lang']]) ? $lang_equiv[$postrow[$i]['user_lang']] : $postrow[$i]['user_lang'];
	$translate_from2 = ($translate_from!=$translate_from2 && $babelfish_lang_code[$translate_from2]) ? $translate_from2 : '';
	if (!empty($translate_from2) && $translate_to!=$translate_from2 && $babelfish_available[$babelfish_lang_code[$translate_from2].'_'.$babelfish_lang_code[$translate_to]]=='yes')
	{	
		if ( $lang['need_pronouns'] == 'yes' )
		{
			$l_translate = sprintf($lang['translate_tooltip'],$lang[$translate_from2][1].$lang[$translate_from2][0],$lang[$translate_to][2].$lang[$translate_to][0]);
		} else
		{
			$l_translate = sprintf($lang['translate_tooltip'],$lang[$translate_from2],$lang[$translate_to]);
		}
		$translate_from_img = '<img src="'.sprintf($images['icon_mini_translate'],$translate_from2.'1').'"';
		$translate_link .= '<a href="http://babelfish.altavista.com/babelfish/trurl_pagecontent?lp=' . $babelfish_lang_code[$translate_from2] . '_' . $babelfish_lang_code[$translate_to] . '&url=' . urlencode($translate_url.$post_id.'&sid='.$userdata['session_id']) . '" target="_blanc">';
		$translate_link .=$translate_from_img.' alt="' . $l_translate. '" title="' . $l_translate. '" border="0" />'.$translate_to_img.'alt="' . $l_translate. '" title="' . $l_translate. '" border="0" /></a>';
	} else
	{
		$translate_from2 = ($lang_equiv[$postrow[$i]['user_lang']]) ? $lang_equiv[$postrow[$i]['user_lang']] : $postrow[$i]['user_lang'];
		$translate_from2 = ($translate_from!=$translate_from2 && $intertran_lang_code[$translate_from2] && $translate_from2!='romanian') ? $translate_from2 : '';
		if (!empty($translate_from2) && $translate_to!=$translate_from2)
		{	
			if ( $lang['need_pronouns'] == 'yes' )
			{
				$l_translate = sprintf($lang['translate_tooltip'],$lang[$translate_from2][1].$lang[$translate_from2][0],$lang[$translate_to][2].$lang[$translate_to][0]);
			} else
			{
				$l_translate = sprintf($lang['translate_tooltip'],$lang[$translate_from2],$lang[$translate_to]);
			}
			$translate_from_img = '<img src="'.sprintf($images['icon_mini_translate'],$translate_from2.'1').'"';
			$translate_link .= '<a href="http://intertran.tranexp.com/Translate/index.shtml?' . 'from=' . $intertran_lang_code[$translate_from2] . '&to=' . $intertran_lang_code[$translate_to] . '&type=url&url=' . urlencode($translate_url.$post_id.'&sid='.$userdata['session_id'].'#'.$post_id) . '" target="_blanc">';
			$translate_link .=$translate_from_img.' alt="' . $l_translate. '" title="' . $l_translate. '" border="0" />'.$translate_to_img.'alt="' . $l_translate. '" title="' . $l_translate. '" border="0" /></a>';
		}
	}
} else
{
	$translate_link = '';
}
// End add - Translate posts MOD

        //-- mod : calendar --------------------------------------------------------------------------------
	//-- add
		if (!empty($topic_calendar_time) && ($postrow[$i]['post_id'] == $topic_first_post_id))
		{
			$post_subject .= get_calendar_title($topic_calendar_time, $topic_calendar_duration);
		}
	//-- fin mod : calendar ----------------------------------------------------------------------------
		$post_subject = get_icon_title($postrow[$i]['post_icon']) . '&nbsp;' . $post_subject;
	switch ( $postrow[$i]['user_level'] )
	{
		case ADMIN:
			$poster_name = '<b>' . $poster . '</b>';
			$style_color = 'style="color:#' . $theme['fontcolor3'] . '"';
			break;
		case JUNIOR_ADMIN:
			$poster_name = '<b>' . $poster . '</b>';
			$style_color = 'style="color:#' . $theme['fontcolor5'] . '"';
			break;
		case SPONSOR:
			$poster_name = '<b>' . $poster . '</b>';
			$style_color = 'style="color:#' . $theme['fontcolor7'] . '"';
			break;
		case VIP:
			$poster_name = '<b>' . $poster . '</b>';
			$style_color = 'style="color:#' . $theme['fontcolor8'] . '"';
			break;
		case MOD:
			$poster_name = '<b>' . $poster . '</b>';
			$style_color = 'style="color:#' . $theme['fontcolor2'] . '"';
			break;
		default:
			$poster_name = $poster;
			$style_color = '';
			break;
	}

	if ( $poster_id != ANONYMOUS )
	{
		if ( $userdata['user_level'] != ADMIN )
		{
			$poster_name = '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $poster_id) . '"' . $style_color . '>' . $poster_name . '</a>';
		}
		else
		{
			$poster_name = '<a href="' . "admin/admin_users.$phpEx?mode=edit&amp;" . POST_USERS_URL . "=" . $poster_id . "&amp;sid=" . $userdata['session_id'] . '" target="_blank"' . $style_color . '>' . $poster . '</a>';
		}
	}
//<!-- BEGIN Unread Post Information to Database Mod   -->    
   if($userdata['upi2db_access']) 
   { 
       $post_edit_max = ($postrow[$i]['post_time'] >= $postrow[$i]['post_edit_time']) ? 

$postrow[$i]['post_time'] : $postrow[$i]['post_edit_time']; 
       $post_time_max = (empty($board_config['upi2db_edit_as_new'])) ? 

$postrow[$i]['post_time'] : $post_edit_max; 
       $post_id = $postrow[$i]['post_id']; 
       
       $mark_topic_unread = mark_post_viewtopic($post_time_max, $unread, $topic_id, 

$forum_id, $post_id, $except_time, $forum_topic_data['topic_type']); 
   } 
   else 
   { 
       $mark_topic_unread = ''; 
   } 
//<!-- END Unread Post Information to Database Mod   -->
	//
	// Again this will be handled by the templating
	// code at some point
	//
	$row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2']; 
$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];


	// BEGIN cmx_mod
		$news_label = ( $topic_rowset[$i]['news_id'] > 0 ) ? $lang['News'] . ':' : '';
	// END cmx_mod

	if ($postrow[$i]['user_id'] != ANONYMOUS)
	{
		/* Begin HP/MP/EXP Mod
		 *
		 * Note: all new variables used created in this mod
		 * are prefixed with level_ to be sure of not overwriting
		 * other variables.
		 *
		 */

		/* Calculate Level
		 * A user's level is determined by their total number of posts.
		 * A nice mathmatical formula is used to translate their post count
		 * into an intager level.
		 *
		 * Note: A user with zero (0) posts is considered level 0, however
		 * making one (1) post, raises them to level 1.
		 *
		 */

		if($postrow[$i]['user_posts'] < 1)
		{
			$level_level = 0;
		}
		else
		{
			$level_level = floor( pow( log10( $postrow[$i]['user_posts'] ), 3 ) ) + 1;
		}

		/* Determine Hit Points (HP)
		 *
		 * Hp is based on user activity.
		 * Max HP is based on the user's level, and will generally
		 * be the same for all users of the same level.
		 *
		 * A user's current HP is based on the user's posts per day.
		 * A higher post per day (ppd), the more HP they will have. A
		 * user with an average PPD (set below) will have 50% of their
		 * max HP. As a user goes over the average PPD, they will have
		 * more HP, but the gains will decrease as the user's PPD increases.
		 * This makes achieving 100% hp difficult, but not impossible.
		 *
		 * For users with under the average PPD, they will have HP equal
		 * to 1/2 the percentage their ppd is of the average.
		 * ie- a user with 2.5 ppd, and an average ppd of 5 will have
		 * 25% of their max HP. This is because 2.5 is 50% of 5, and 1/2
		 * of that, is 25%.
		 *
		 * Users who manage to post so far above the average that they have
		 * more HP than their max will recieve a bonus to their max HP.
		 *
		 * Note that users at level 0 will always have 0 / 0 hp.
		 *
		 */

		/*
		 * This value determines the 'average' posts per day.
		 * The admin may redefine this variable as he wishes.
		 * Higher values will generally decrease users' HP, and
		 * lower values will generally increase users' HP.
		 *
		 * Note: Do NOT set this value to zero (0).
		 * This -may- be set to a fractional value (eg, 5.1, 3.1415)
		 *
		 */

		$level_avg_ppd = 5;

		/*
		 * this value sets how hard it is to achieve 100%
		 * hp. The higher you set it, the harder it is to
		 * get full hp.
		 *
		 * to judge how high to set it, a user must have
		 * posts per day equal to the $level_avg_ppd plus
		 * the number set below.
		 *
		 * This should NOT be zero.
		 */

		$level_bonus_redux = 5;

		/*
		 * We need to actually calculate the user's posts per day
		 * because unlike in the profile, it's not done for us.
		 *
		 */
		$level_user_ppd = ($postrow[$i]['user_posts'] / max(1, round( ( time() - $postrow[$i]['user_regdate'] ) / 86400 )));

		if($level_level < 1)
		{
			$level_hp = "0 / 0";
			$level_hp_percent = 0;
		}
		else
		{
			$level_max_hp = floor( (pow( $level_level, (1/4) ) ) * (pow( 10, pow( $level_level+2, (1/3) ) ) ) / (1.5) );

			if($level_user_ppd >= $level_avg_ppd)
			{
				$level_hp_percent = floor( (.5 + (($level_user_ppd - $level_avg_ppd) / ($level_bonus_redux * 2)) ) * 100);
			}
			else
			{
				$level_hp_percent = floor( $level_user_ppd / ($level_avg_ppd / 50) );
			}

			if($level_hp_percent > 100)
			{
				//Give the user a bonus to max HP for greater than 100% hp.
				$level_max_hp += floor( ($level_hp_percent - 100) * pi() );
				$level_hp_percent = 100;
			}
			else
			{
				$level_hp_percent = max(0, $level_hp_percent);
			}

			$level_cur_hp = floor($level_max_hp * ($level_hp_percent / 100) );

			//Be sure a user has no more than max, and no less than zero hp.
			$level_cur_hp = max(0, $level_cur_hp);
			$level_cur_hp = min($level_max_hp, $level_cur_hp);

			$level_hp = $level_cur_hp . ' / ' . $level_max_hp;
		}

		/* Determine MP
		 *
		 * MP is calculated by how long the user has been around
		 * and how often they post.
		 *
		 * Max MP is based on level, and increases with level
		 * Each post a user makes costs them mp,
		 * and a user regenerates mp proportional to how
		 * many days they have been registered
		 *
		 */

		//Number of days the user has been at the forums.
		$level_user_days = max(1, round( ( time() - $postrow[$i]['user_regdate'] ) / 86400 ));

		/* The mp cost for one post.
		 * Raising this value will generally decrease the current
		 * mp for most posters.
		 * This may be set to a decimal value (eg, 2, 2.1, 3.141596)
		 * This should NOT be set to 0
		 */
		$level_post_mp_cost = 2.5;

		/* This determines how much mp a user regenerates per day
		 * Raising this value will generally increase the current
		 * mp for most posters.
		 * This may be set to a decimal value (eg, 3, 3.5, 2.71828)
		 * This should NOT be set to 0
		 */
		$level_mp_regen_per_day = 4;

		if($level_level < 1)
		{
			$level_mp = '0 / 0';
			$level_mp_percent = 0;
		}
		else
		{
			$level_max_mp = floor( (pow( $level_level, (1/4) ) ) * (pow( 10, pow( $level_level+2, (1/3) ) ) ) / (pi()) );

			$level_mp_cost = $postrow[$i]['user_posts'] * $level_post_mp_cost;
			$level_mp_regen = max(1, $level_user_days * $level_mp_regen_per_day);

			$level_cur_mp = floor($level_max_mp - $level_mp_cost + $level_mp_regen);
			$level_cur_mp = max(0, $level_cur_mp);
			$level_cur_mp = min($level_max_mp, $level_cur_mp);

			$level_mp = $level_cur_mp . ' / ' . $level_max_mp;
			$level_mp_percent = floor($level_cur_mp / $level_max_mp * 100 );

		}

		/* Determine EXP percentage
		 *
		 * Experience is determined by how far the user is away
		 * from the next level. This is expressed as a percentage.
		 *
		 * Note, a user of level 0 has 100% experience. Making one post
		 * will put them at level 1. Also, a user that is shown to have 100%
		 * experience, will go up a level on their next post.
		 *
		 */

		if($level_level == 0)
		{
			$level_exp = "0 / 0";
			$level_exp_percent = 100;
		}
		else
		{
			$level_posts_for_next = floor( pow( 10, pow( $level_level, (1/3) ) ) );


			$level_posts_for_this = max(1, floor( pow( 10, pow( ($level_level - 1), (1/3) ) ) ) );



			$level_exp = ($postrow[$i]['user_posts'] - $level_posts_for_this) . " / " . ($level_posts_for_next - $level_posts_for_this);

			$level_exp_percent = floor( ( ($postrow[$i]['user_posts'] - $level_posts_for_this) / max( 1, ($level_posts_for_next - $level_posts_for_this ) ) ) * 100);
		}

		/* END HP/MP/EXP MOD */
	}
/*
	if (($postrow[$i]['user_session_time'] >= ( time() - 300 )) && ($postrow[$i]['user_allow_viewonline']))
	{
		$on_off_hidden = '<img src="' . $images['icon_online'] . '" alt="' . $lang['Online'] . '" title="' . $lang['Online'] . '" border="0" />';
	}
	else if (($postrow[$i]['user_allow_viewonline']) == 0)
	{
		$on_off_hidden = '<img src="' . $images['icon_hidden'] . '" alt="' . $lang['Hidden'] . '" title="' . $lang['Hidden'] . '" border="0" />';
	}
	else if ($poster_id == ANONYMOUS)
	{
		$on_off_hidden = '';
	}
	else
	{
		$on_off_hidden = '<img src="' . $images['icon_offline'] . '" alt="' . $lang['Offline'] . '" title="' . $lang['Offline'] . '" border="0" />';
	}
*/
	$nickpage_img = '<img src="'.  $images['icon_nickpage'] .'" alt="" border="0" />';
	if ($postrow[$i]['user_id'] == ANONYMOUS) 
	{ 
		$poster = '<br /><br /><span style="color: #FF0000">'.$postrow[$i]['post_username'].'</span>'; 
		// 
		// Handle anon users posting with usernames 
		// 
		if ( $postrow[$i]['post_username'] != '' ) 
		{ 
		$poster = $postrow[$i]['post_username'].'<br />'; 
		$poster_rank = $lang['Guest']; 
		$poster_age=''; 
		} 
		$birthday = ''; 
		$zodiac_img = ''; 
		$zodiac = ''; 
		$zodiac = ''; 
		$chinese_img = ''; 
		$chinese = ''; 
		$poster_age = ''; 
	}
if ( (strstr($message, '[admin]')) || (strstr($message, '[moderator]')) || (strstr($message, '[user]')) )
		$message = parse_staff_message_filter($message);
if ( $userdata['user_id'] == ANONYMOUS )
	{
		$poster_joined = '';
		$poster_posts = '';
		$poster_from = '';
		$user_sig = '';
		$l_edited_by = '';
		$profile_img = '';
		$profile = '';
		$search_img = '';
		$search = '';
		$pm_img = '';
		$pm = '';
		$email_img = '';
		$email = '';
		$www_img = '';
		$www = '';
		$icq_status_img = '';
		$icq_img = '';
		$icq = '';
		$aim_img = '';
		$aim = '';
		$msn_img = '';
		$msn = '';
		$yim_img = '';
		$yim = '';
            $birthday = ''; 
		$zodiac_img = ''; 
		$zodiac = ''; 
		$zodiac = ''; 
		$chinese_img = ''; 
		$chinese = ''; 
		$poster_age = ''; 
            $gender_image = '';
            $poster_from_flag = '';	
		$gallery_img = '';
		$gallery = '';
		$poster_from_state_flag = '';
		
		$skype = '';
		$poster_uin = '';
		$post_day_stats = '';
		$post_percent_stats = '';
            $level_level = '';      
		$level_mp_percent = '';
            $level_mp = '';
            $level_hp_percent = '';
            $level_hp = '';	 
$level_exp = '';
$level_exp_percent = '';

			 
			 
			 
			 
			
			 
			 


	}
  
  //
// BEGIN CONTEST
//

++$mcont;

if(($mcont == 1) && $is_auth['auth_contest'])
{

// ------------------------------------
// Viewing contest
// ------------------------------------

include_once($phpbb_root_path . 'album_mod/album_contest.'.$phpEx);
}

//
// END CONTEST
//
  
	$template->assign_block_vars('postrow', array(

		'ROW_COLOR' => '#' . $row_color,
		'ROW_CLASS' => $row_class,
		'POSTER_NAME' => $poster_name,

                'POST_DAY_STATS' => $post_day_stats,
                'POST_PERCENT_STATS' => $post_percent_stats,
		'POSTER_UIN' => $poster_uin,
		'ZODIAC_IMG' => $zodiac_img,
		'ZODIAC' => $zodiac,
		'U_ZODIAC' => $u_zodiac,
		'L_ZODIAC' => ($zodiac) ? $lang['Zodiac'] . ': ' : '',
		'POSTER_AGE' => $poster_age. '  ',
		'CHINESE' => $lang[$chinese],
		'CHINESE_IMG' => $chinese_img,
		'U_CHINESE' => $u_chinese,
		'L_CHINESE' => ($chinese) ? $lang['Chinese_zodiac'] . ': ' : '',
		'POSTER_RANK' => $poster_rank,
		'POSTER_GENDER' => $gender_image,
		'RANK_IMAGE' => $rank_image,

		'POSTER_JOINED' => $poster_joined,
		'POSTER_POSTS' => $poster_posts,
		'POSTER_FROM' => $poster_from,
		'POSTER_FROM_FLAG' => $poster_from_flag,
		// STATEFLAGHACK-start
		'POSTER_FROM_STATE_FLAG' => $poster_from_state_flag,
		// STATEFLAGHACK-end

		'POSTER_AVATAR' => $poster_avatar,
		'L_NEWS' => $news_label,

		'POSTER_ONLINE' => $user_onlinestatus,
		'POST_DATE' => $post_date,
// Start add - Postnumber (Count) MOD
		'POST_NUMBER' => ($i + $start + 1),
		'POST_REPLIES' => $total_replies,
		// End add - Postnumber (Count) MOD
		'POST_SUBJECT' => $post_subject,
'POST_EXTRA' => $post_extra,
		'MESSAGE' => $message,
		'SIGNATURE' => $user_sig,
		'EDITED_MESSAGE' => $l_edited_by,
               // 'POSTER_ONLINE' => (($postrow[$i]['user_session_time'] >= ( time() - 300 )) && ($postrow[$i]['user_allow_viewonline'])) ? '<img src="images/online.gif' . $images['Online'] . '" alt="' . $lang['Online'] . '" title="' . $lang['Online'] . '" border="0" />' : '<img src="images/offline.gif' . $images['Offline'] . '" alt="' . $lang['Offline'] . '" title="' . $lang['Offline'] . '" border="0" />',
		'MINI_POST_IMG' => $mini_post_img,
		'PROFILE_IMG' => $profile_img,
		//Begin Mini Profile MOD
		'MINIPROFILE' => append_sid("profile.$phpEx?mode=miniprofile&amp;" . POST_USERS_URL .'=' . $poster_id),
		//End Mini Profile MOD
		'PROFILE' => $profile,
		'SEARCH_IMG' => $search_img,
		'SEARCH' => $search,
		'PM_IMG' => $pm_img,
		'PM' => $pm,
		'NICKPAGE_IMG' => $nickpage_img,
		'GALLERY_IMG' => $gallery_img,
		'GALLERY' => $gallery,
		'EMAIL_IMG' => $email_img,
		'EMAIL' => $email,
		'WWW_IMG' => $www_img,
		'WWW' => $www,
		'ICQ_STATUS_IMG' => $icq_status_img,
		'ICQ_IMG' => $icq_img,
		'ICQ' => $icq,
		'AIM_IMG' => $aim_img,
		'AIM' => $aim,
		'MSN_IMG' => $msn_img,
		'MSN' => $msn,
             
		'SKYPE_IMG' => $skype,
		'YIM_IMG' => $yim_img,
		'YIM' => $yim,
		'EDIT_IMG' => $edit_img,
		'EDIT' => $edit,
		'QUOTE_IMG' => $quote_img,
		'QUOTE' => $quote,
		'IP_IMG' => $ip_img,
		'TOPIC_VIEW_IMG' => $topic_view_img,
		'IP' => $ip,
		'DELETE_IMG' => $delpost_img,
		'DELETE' => $delpost,
// Cache Posts
		'CPS_STATUS' => $parse_status,
		'CPS_IMG' => ($is_auth['auth_mod'] && $board_config['allow_cache_moderate'] || $userdata['user_level'] == ADMIN) ? $cps_img : '',
		// Cache Posts
		'USER_WARNINGS' => $user_warnings,
		'CARD_IMG' => $card_img,
		'CARD_HIDDEN_FIELDS' => $card_hidden,
		'CARD_EXTRA_SPACE' => ($r_card_img || $y_card_img || $g_card_img || $b_card_img) ? '&nbsp;' : '',
		'L_GENDER' => $lang['Gender'],

		'L_MINI_POST_ALT' => $mini_post_alt,

		'U_MINI_POST' => $mini_post_url,
//<!-- BEGIN Unread Post Information to Database Mod	-->	
		'UNREAD_IMG' => $mark_topic_unread,
		'UNREAD_COLOR' => $unread_color,
//<!-- END Unread Post Information to Database Mod	-->
                'U_POST_TRANSLATE' => $translate_link,
                'POSTER_STYLE' => $poster_style_color,
		'U_G_CARD' => $g_card_img,
		'U_Y_CARD' => $y_card_img,
		'U_R_CARD' => $r_card_img,
		'U_B_CARD' => $b_card_img,
		'S_CARD' => append_sid("card.".$phpEx),
		'U_POST_ID' => $postrow[$i]['post_id'])
	);

	if ($postrow[$i]['user_id'] != ANONYMOUS) 
	{
		$template->assign_block_vars('postrow.switch_poster_not_guest', array(
			 "POSTER_HP" => $level_hp,
			 "POSTER_HP_WIDTH" => $level_hp_percent,
			 "POSTER_HP_EMPTY" => ( 100 - $level_hp_percent ),
			 "POSTER_MP" => $level_mp,
			 "POSTER_MP_WIDTH" => $level_mp_percent,
			 "POSTER_MP_EMPTY" => ( 100 - $level_mp_percent ),
			 "POSTER_EXP" => $level_exp,
			 "POSTER_EXP_WIDTH" => $level_exp_percent,
			 "POSTER_EXP_EMPTY" => ( 100 - $level_exp_percent ),
			 "POSTER_LEVEL" =>  $level_level)
		);
	}


	
	

	display_post_attachments($postrow[$i]['post_id'], $postrow[$i]['post_attachment']);

// Start add - Show usergroups MOD
	if (display_usergroups($userdata['user_id'],$poster_id,'postrow'))
	{
		$template->append_block_vars('postrow',array(
		'L_USER_GROUP' =>$lang['Usergroups'],
		'L_GO' => $lang['Go']));
	} else
	{
		$template->append_block_vars('postrow',array(
		'L_NO_USER_GROUP' =>$lang['Usergroups'],
		'L_NO_USERGROUPS'=> $lang['None']));
	} 
// End add - Show usergroups MOD

}
include($phpbb_root_path . 'quick_reply.'.$phpEx);

$template->assign_vars(array( 
"TELL_LINK" => append_sid("http://".$HTTP_SERVER_VARS['HTTP_HOST'].$HTTP_SERVER_VARS['PHP_SELF']."?t=$topic_id", true)));
//<!-- END Unread Post Information to Database Mod	-->
if($userdata['upi2db_access'])
{
    delete_read_posts($read_posts);
}
//<!-- END Unread Post Information to Database Mod	-->
   
$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
?>